#!/bin/bash

cd /var/www

echo "Did you clear out your settings first? See https://wikid.netapp.com/w/Mercury/Mercury_Development/Creating_FMC_NoContent_DB for details."

echo "Creating backup file..."

# First export with data for most tables.
# Simpletest is excluded entirely, only applies to dev.
mysqldump -u root -pzaloni.12 --all-databases --order-by-primary --ignore-table=mercury.watchdog --ignore-table=mercury.cache --ignore-table=mercury.cache_bootstrap --ignore-table=mercury.cache_field --ignore-table=mercury.cache_form --ignore-table=mercury.cache_menu --ignore-table=mercury.cache_path --ignore-table=mercury.cache_token --ignore-table=mercury.cache_update --ignore-table=mercury.cache_views --ignore-table=mercury.ctools_css_cache --ignore-table=mercury.ctools_object_cache --ignore-table=mercury.field_data_field_fa_cache_mode --ignore-table=mercury.field_revision_field_fa_cache_mode --ignore-table=mercury.mercury_utilities_import_saved_credentials --ignore-table=mercury.search_index --ignore-table=mercury.search_dataset --ignore-table=mercury.search_total --ignore-table=mercury.search_api_item --ignore-table=mercury.sessions --ignore-table=mercury.simpletest --ignore-table=mercury.simpletest_test_id > mercury_nocontent.sql

# Now export empty tables where we shouldn't export data.
# This is mainly just for tables that are hard to keep empty, like cache tables.
# On any page load they fill back up!
echo "USE mercury;" >> mercury_nocontent.sql
mysqldump -uroot -pzaloni.12 --no-data mercury watchdog cache cache_bootstrap cache_field cache_form cache_menu cache_path cache_token cache_update cache_views ctools_css_cache ctools_object_cache field_data_field_fa_cache_mode field_revision_field_fa_cache_mode mercury_utilities_import_saved_credentials search_index search_dataset search_total search_api_item sessions >> mercury_nocontent.sql

echo "/var/www/mercury_nocontent.sql created!"
