<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions to help with form handling.
 */

function famc_analytics_vm_historical_perf_form($form, &$form_state, $vm_nid) {

  $set_values = famc_analytics_form_defaults('vm_hist_perf', $vm_nid);

  $node = node_load($vm_nid);
  drupal_set_title($node->title);

  $metrics = famc_analytics_metrics();

  $form['metric'] = array(
    '#type' => 'select',
    '#title' => 'Select Metric',
    '#options' => famc_analytics_format_metric_list(),
    '#default_value' => FAMC_ANALYTICS_METRIC_DEFAULT,
  );

  $intervals = famc_analytics_metric_intervals();

  $form['from'] = array(
    '#type' => 'select',
    '#title' => 'Start',
    '#options' => array_map(function ($value) {
        return ($value == 0 ? $value : t('@value ago', array('@value' => $value)));
      }, $intervals),
    '#default_value' => FAMC_ANALYTICS_METRIC_DEFAULT_PERIOD,
  );

  $form['to'] = array(
    '#type' => 'select',
    '#title' => 'Duration',
    '#options' => array_slice($intervals, 0, sizeof($intervals), TRUE),
    '#default_value' => FAMC_ANALYTICS_METRIC_DEFAULT_PERIOD,
  );

  if (!empty($set_values)) {
    $form['metric']['#default_value'] = $set_values['metric'];
    $form['from']['#default_value'] = $set_values['from'];
    $form['to']['#default_value'] = $set_values['to'];
  }

  $form['save'] = array(
    '#type' => 'submit',
    '#value' => 'Update',
  );

  $form['graph'] = array(
    '#markup' => '<div id="famc-vm-hist-graph"></div>',
  );

  $form['nid'] = array(
    '#type' => 'hidden',
    '#value' => $vm_nid,
  );

  // If the options have been set then set the JS vars for the graph
  famc_analytics_render_hist_perf_graph('vm', $vm_nid);

  return $form;
}

function famc_analytics_analytics_form($form, &$form_state) {

  // If session records are there then go to the graph view
  if (famc_analytics_analytics_form_submitted()) {
    drupal_goto('analytics/view');
  }

  //
  //
    //// If session values not yet set after submit
  //if (empty($set_values['from']) && !empty($form_state['input'])) {
  //  $set_values += $form_state['input'];
  //}
  //
    //$entity_count = (isset($set_values['entities']) && is_array($set_values['entities'])) ? sizeof($set_values['entities']) : 0;

  $metrics = famc_analytics_metrics();
  $intervals = famc_analytics_metric_intervals();

  //$form['selector'] = array(
  //  '#markup' => '<div class="famc-analytics-form-row">
  //                  <label>' .
  //                    t('What do you want to report on?') .
  //                  '</label>
  //                  <span class="mercury-button">' .
  //                    famc_analytics_ctools_popup_link(FAMC_ANALYTICS_VM_NODE_TYPE, 'VMs', 'VMs', 'famc-analytics-vm-selector-link') .
  //                  '</span>
  //                  <span class="mercury-button">' .
  //                    famc_analytics_ctools_popup_link(FAMC_ANALYTICS_HOST_NODE_TYPE, 'Hosts', 'Hosts', 'famc-analytics-host-selector-link') .
  //                  '</span>
  //                </div>',
  //);

  $form['selector'] = array(
    '#markup' => '<div class="famc-analytics-form-row">
                      <label>' .
    t('What do you want to report on?') .
    '</label>
                      <span class="mercury-button">' .
    famc_analytics_ctools_popup_link(FAMC_ANALYTICS_VM_NODE_TYPE, 'Select VMs', 'Select VMs', 'famc-analytics-vm-selector-link') .
    '</span>
                    </div>',
  );

  //$form['selections'] = array(
  //  '#markup' => '<div class="famc-analytics-form-row">
  //                  <label>' .
  //                    t('Which VMs and Hosts do you want to see?') .
  //                  '</label>
  //                  <span id="famc-analytics-vm-selections" class="famc-analytics-selections">' .
  //                    t('VMs: ') .
  //                    '<span></span>
  //                  </span>
  //                  <span id="famc-analytics-host-selections" class="famc-analytics-selections">' .
  //                    t('Hosts: ') .
  //                  ' <span></span>
  //                  </span>
  //                </div>',
  //);

  $form['selections'] = array(
    '#markup' => '<div class="famc-analytics-form-row">
                      <label>' .
    t('Selected VMs') .
    '</label>
                      <span id="famc-analytics-vm-selections" class="famc-analytics-selections"><span></span></span>
                    </div>',
  );

  $form['time_span_label'] = array(
    '#markup' => '<label>' . t('Select time span') . '</label>',
  );

  $form['from'] = array(
    '#type' => 'select',
    '#title' => 'Start',
    '#options' => array_map(function ($value) {
        return ($value == 0 ? $value : t('@value ago', array('@value' => $value)));
      }, $intervals),
    '#default_value' => FAMC_ANALYTICS_METRIC_DEFAULT_PERIOD,
  );

  $form['to'] = array(
    '#type' => 'select',
    '#title' => 'Duration',
    '#options' => array_slice($intervals, 0, sizeof($intervals), TRUE),
    '#default_value' => 0,
  );

  $form['metric'] = array(
    '#type' => 'select',
    '#title' => 'Select Metric',
    '#description' => 'Note: Metrics for only a single VM can be shown for metric collections - "All Latencies", "All Ops" and "All Rates".',
    '#options' => famc_analytics_format_metric_list(),
    '#default_value' => FAMC_ANALYTICS_METRIC_DEFAULT,
  );

  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Generate Report'),
  );

  return $form;
}

/**
 *  Form builder for the Analytics view page
 */
function famc_analytics_analytics_view_form($form, &$form_state) {

  if (!famc_analytics_analytics_form_submitted()) {
    drupal_set_message(t('Please select at least one VM to generate a report.'), 'error');
    drupal_goto('analytics');
  }

  $set_values = famc_analytics_form_defaults('analytics');
  $metrics = famc_analytics_metrics();
  $intervals = famc_analytics_metric_intervals();

  $form = array();

  $place_holders = array(
    '@metric' => $metrics[$set_values['metric']]['label'],
    '@count' => sizeof($set_values['entities']),
    '@from' => $intervals[$set_values['from']],
    '@to' => $intervals[$set_values['to']],
  );

  $form['message'] = array(
    '#markup' => '<div class="analytics-message">' .
    t('Displaying metrics from @from ago for a duration of @to', $place_holders) .
    '</div>',
  );

  $form['reset'] = array(
    '#type' => 'submit',
    '#value' => t('New Report'),
  );

  $form['metric'] = array(
    '#type' => 'select',
    '#title' => 'Select Metric',
    '#description' => 'Note: Metrics for only a single VM can be shown for metric collections - "All Latencies", "All Ops" and "All Rates".',
    '#options' => famc_analytics_format_metric_list(),
    '#default_value' => $set_values['metric'],
  );

  $form['update'] = array(
    '#type' => 'submit',
    '#value' => t('Update'),
  );

  $form['graph'] = array(
    '#markup' => '<div id="famc-analytics-graph" style="width; 700px"></div>',
  );

  famc_analytics_render_analytics_graph(FAMC_ANALYTICS_VM_NODE_TYPE, $set_values['entities']);

  return $form;
}

// Implements hook_theme()
function famc_analytics_theme(&$existing, &$type, &$theme, &$path) {

  return array(
    'famc_analytics_vm_historical_perf_form' => array(
      'render element' => 'form',
    ),
    'famc_analytics_analytics_form' => array(
      'render element' => 'form',
    ),
    'famc_analytics_analytics_view_form' => array(
      'render element' => 'form',
    ),
  );
}

// Theme callback for the VM historical perf form
function theme_famc_analytics_vm_historical_perf_form($variables) {

  $form = $variables['form'];

  $form['save']['#prefix'] = '<div class="form-submit">';
  $form['save']['#suffix'] = '</div>';

  $output = '';

  $output .= '<div class="node-inner-section clearfix">';
  $output .= '  <div class="node-inner-header">' . t('Configuration') . '</div>';
  $output .= '  <div class="hist-perf-metric-content">';
  $output .= '    <div class="hist-perf-metric-config clearfix">';
  $output .= '      <div class="vm-hist-perf-metric-wrapper">' . drupal_render($form['metric']) . '</div>';
  $output .= '      <div class="vm-hist-perf-date-wrapper">';
  $output .= drupal_render($form['from']) . drupal_render($form['to']) . drupal_render($form['save']);
  $output .= '      </div>';
  $output .= '    </div>';
  $output .= '    <div class="hist-perf-metric-graph clearfix" style="width: 740px;">';
  $output .= drupal_render($form['graph']);
  $output .= '    </div>';
  $output .= '  </div>';
  $output .= '</div>';
  $output .= drupal_render_children($form);

  return $output;
}

// Theme callback for the analytics form
function theme_famc_analytics_analytics_form($variables) {

  $form = $variables['form'];

  $form['save']['#prefix'] = '<div class="form-submit">';
  $form['save']['#suffix'] = '</div>';

  $output = '';

  $output .= '<div class="node-inner-section clearfix">';
  $output .= '  <div class="node-inner-header">' . t('Name') . '</div>';
  $output .= '  <div class="hist-perf-metric-content analytics-content">';
  $output .= '    <div class="anaytics-config clearfix">';
  $output .= drupal_render($form['selector']);
  $output .= drupal_render($form['selections']);
  $output .= '      <div class="famc-analytics-form-row">';
  $output .= drupal_render($form['time_span_label']);
  $output .= '        <div class="analytics-dates-wrapper clearfix">';
  $output .= drupal_render($form['from']);
  $output .= drupal_render($form['to']);
  $output .= '        </div>';
  $output .= '      </div>';
  $output .= '      <div class="famc-analytics-form-row last">';
  $output .= drupal_render($form['metric']);
  $output .= drupal_render($form['save']);
  $output .= '      </div>';
  $output .= '    </div>';
  $output .= '    <div class="hist-perf-metric-graph analytics-graph clearfix" style="width: 740px;">';
  $output .= drupal_render($form['graph']);
  $output .= '    </div>';
  $output .= '  </div>';
  $output .= '</div>';
  $output .= drupal_render_children($form);

  return $output;
}

// Theme callback for the analytics view form
function theme_famc_analytics_analytics_view_form($variables) {

  $form = $variables['form'];

  $form['reset']['#prefix'] = '<div class="form-submit">';
  $form['reset']['#suffix'] = '</div>';

  $form['update']['#prefix'] = '<div class="form-submit">';
  $form['update']['#suffix'] = '</div>';

  $output = '';

  $output .= '<div class="node-inner-section clearfix">';
  $output .= '  <div class="node-inner-header">' . t('Showing') . '</div>';
  $output .= '  <div class="hist-perf-metric-content analytics-content">';
  $output .= '    <div class="famc-analytics-form-row clearfix">';
  $output .= drupal_render($form['message']);
  $output .= drupal_render($form['metric']);
  $output .= drupal_render($form['update']);
  $output .= '    </div>';
  $output .= '    <div class="famc-analytics-form-row clearfix analytics-reset">';
  $output .= drupal_render($form['reset']);
  $output .= '    </div>';
  $output .= '    <div class="hist-perf-metric-graph analytics-graph clearfix" style="width: 740px;">';
  $output .= drupal_render($form['graph']);
  $output .= '    </div>';
  $output .= '  </div>';
  $output .= '</div>';
  $output .= drupal_render_children($form);

  return $output;
}

/**
 *  Get the metric intervals
 */
function famc_analytics_metric_intervals() {

  return array(
    '15' => t('15 Minutes'),
    '30' => t('30 Minutes'),
    '60' => t('1 Hour'),
    '120' => t('2 Hours'),
    '180' => t('3 Hours'),
    '360' => t('6 Hours'),
    '720' => t('12 Hours'),
    '1080' => t('18 Hours'),
    '1440' => t('24 Hours'),
  );
}

function famc_analytics_vm_historical_perf_form_validate($form, &$form_state) {

  //if ($form_state['values']['from'] < $form_state['values']['to']) {
  //  form_set_error('from', 'The From time should be before the To time.');
  //}
}

function famc_analytics_vm_historical_perf_form_submit($form, &$form_state) {

  $_SESSION['vm_hist_perf'][$form_state['values']['nid']] = array(
    'from' => $form_state['values']['from'],
    'to' => $form_state['values']['to'],
    'metric' => $form_state['values']['metric'],
  );
}

function famc_analytics_analytics_form_validate($form, &$form_state) {

  if (!isset($_SESSION['analytics']['entities']) && empty($_SESSION['analytics']['entities'])) {
    form_set_error('selector', 'Please select at least one VM to generate a report.');
  }

  if (isset($_SESSION['analytics']['entities']) && !empty($_SESSION['analytics']['entities']) && sizeof($_SESSION['analytics']['entities']) > 1) {
    if (preg_match('/^group-(.*)$/', $form_state['values']['metric'])) {
      form_set_error('selector', 'The collective metrics "All Latencies", "All Ops" and "All Rates" can be shown for a single VM only.');
    }
  }
}

function famc_analytics_analytics_form_submit($form, &$form_state) {

  $entities = $_SESSION['analytics']['entities'];

  $_SESSION['analytics'] = array(
    'from' => $form_state['values']['from'],
    'to' => $form_state['values']['to'],
    'metric' => $form_state['values']['metric'],
    'entities' => $entities,
  );

  drupal_goto('analytics/view');
}

function famc_analytics_analytics_view_form_submit($form, &$form_state) {

  if ($form_state['values']['op'] == t('Update')) {
    if (isset($_SESSION['analytics']['entities']) && !empty($_SESSION['analytics']['entities']) && sizeof($_SESSION['analytics']['entities']) > 1) {
      if (preg_match('/^group-(.*)$/', $form_state['values']['metric'])) {
        form_set_error('selector', 'The collective metrics "All Latencies", "All Ops" and "All Rates" can be shown for a single VM only.');
      } else {
        $_SESSION['analytics']['metric'] = $form_state['values']['metric'];
      }
    } else {
      $_SESSION['analytics']['metric'] = $form_state['values']['metric'];
    }
  } else {
    unset($_SESSION['analytics']['entities']);
    unset($_SESSION['analytics']);

    drupal_goto('analytics');
  }
}

function famc_analytics_form_defaults($session_key, $entity_id = NULL) {

  $session_values = array();

  if (isset($_SESSION[$session_key])) {
    $session_values = $_SESSION[$session_key];
    if (!empty($entity_id)) {
      $session_values = ( isset($session_values[$entity_id]) ? $session_values[$entity_id] : array() );
    }
  }

  return $session_values;
}

/**
 * Get a selectable list of host/vm entities
 */
function famc_analytics_get_entity_select_form($form, &$form_state) {

  $form = array();
  if (!empty($form_state['entity_type'])) {
    $entity_type = $form_state['entity_type'];
  }

  $entities = famc_analytics_get_entities($entity_type);
  $entity_array = array();
  foreach ($entities as $nid => $entity) {
    $entity = node_load($nid);
    $driver_status = field_get_items('node', $entity, 'field_driver_status');
    $allocate_status = field_get_items('node', $entity, 'field_cachespace');
    if ($driver_status[0]['value'] == "Agent Installed" && $allocate_status[0]['value'] != '') {
      $entity_array[$nid] = $entity->title;
    }
  }

  $form['entities'] = array(
    '#title' => 'Select',
    '#type' => 'checkboxes',
    '#options' => $entity_array,
    '#default_value' => (isset($_SESSION['analytics']['entities']) ? $_SESSION['analytics']['entities'] : array()),
  );

  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Submit',
    '#prefix' => '<div class="form-submit">',
    '#suffix' => '</div>',
  );

  return $form;
}

/**
 * Get a selectable list of host/vm entities
 */
function famc_analytics_get_entity_select_form_submit($form, &$form_state) {

  $entities = $form_state['values']['entities'];

  $_SESSION['analytics']['entities'] = famc_analytics_get_checked_values($entities);
}

/**
 * Get the checked values from checkboxes submission
 */
function famc_analytics_get_checked_values($values) {

  $checked_values = array();

  foreach ($values as $id => $checked) {
    if ($checked) {
      $checked_values[] = $id;
    }
  }

  return $checked_values;
}

/**
 * Check if the analytics form has been submitted
 */
function famc_analytics_analytics_form_submitted() {

  $return = FALSE;

  if (isset($_SESSION['analytics']) && isset($_SESSION['analytics']['from']) && isset($_SESSION['analytics']['entities']) &&
    is_array($_SESSION['analytics']['entities']) && !empty($_SESSION['analytics']['entities'])) {

    $return = TRUE;
  }

  return $return;
}
