<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *  FMC includes works under other copyright notices and distributed
 *  according to the terms of the GNU General Public License or a compatible
 *  license, including:
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 *
 */

/**
 *  Generates the fmc-messages.txt
 *  This file will contain the last 1000 lines of /var/log/messages
 *  file in fmc VM. This will help in knowing the common errors
 *
 *  This function will return the log file contents as text
 * @deprecated is now generalized
*/
function gen_fmc_messages()
{
	$messages = array();
	exec ("sudo perl /var/www/mercury/sites/all/modules/custom/famc_asup/parse_log.pl /var/log/messages | tail -1000", $messages);

	$log = "";
	foreach ($messages as $message) {
		$log .= $message . "\n";
	}
	return $log;
}

function gen_fa_watchdog() {
  // There is no function to write CSV data to a string, so use the
  // memory stream wrapper instead.
  // XXX: We could get rid of this if we stop returning the data
  // and just write to the file instead.
  $fh = fopen('php://memory', 'rw');

  // Collect all relevant watchdog info.
  // These lines tend to be long, so limit to 3000.
  $query = db_query('SELECT * FROM {watchdog} ORDER BY wid DESC LIMIT 3000');
  $headers = array();
  foreach ($query as $row) {
    $row = (array) $row;

    // For the first row, add the column headers.
    if (empty($headers)) {
      $headers = array_keys($row);
      fputcsv($fh, $headers);
    }

    // Add the row to the CSV.
    fputcsv($fh, $row);
  }

  // Pull the data back out.
  rewind($fh);
  $contents = '';
  while (!feof($fh)) {
    $contents .= fread($fh, 8192);
  }

  // Clean up and return.
  fclose($fh);
  return $contents;
}

function gen_fa_user_details() {
  // We want basic user info, but remove sensitive or verbose data.
  global $user;
  $export_user = clone($user);
  unset($export_user->pass, $export_user->session);
  $result = var_export($export_user, true) . "\n\n";

  // The server config includes the user agent string, etc.
  $result .= var_export($_SERVER, true) . "\n\n";
  return $result;
}
