<?php

/**
 *  Generates the x-header-data file containing the info regarding the ASUP for backend processing
 *  
 *
 * @param hostname
 *   name of the host which generates ASUP 
 * @param company
 *   company name collected during install
 * @param site
 *   site name collected during install 
 * @param system_id
 *   unique identifier generated during install 
 * @param subject
 *   subject of ASUP
 * @param gentime
 *   generation time of ASUP
 *   
 * Return value
 *  This function will return the header file contents as txt
*/
function gen_x_header_data($hostname, $company, $site, $system_id, $subject, $gentime, $fa_version, $from, $fa_model, $os_version)
{
	ini_set('precision', 20);

	$hdr = "";

	$hdr .= "X-Netapp-asup-subject : $subject\n";
	$hdr .= "X-Netapp-asup-hostname : $hostname\n";
	$hdr .= "X-Netapp-asup-system-id : $system_id\n";
	$hdr .= "X-Netapp-asup-model-name : $fa_model\n";
	$hdr .= "X-Netapp-asup-os-version : $fa_version\n";
	$hdr .= "X-Netapp-asup-product-company : $company\n";
	$hdr .= "X-Netapp-asup-product-site : $site\n";
	$hdr .= "X-Netapp-asup-generated-on : $gentime\n";
//	$hdr .= "X-Netapp-asup-from : $from\n";
	// Bring this back on when we implement asup sequence numbering
//	$hdr .= "X-Netapp-asup-sequence : 11\n";
//	$hdr .= "X-Netapp-asup-os-version : $os_version\n";

	return $hdr;
}

