#!/usr/bin/perl

# Syslog is highly redundant with messages.
# Only output unique content.
if ($ARGV[0] eq '/var/log/syslog') {
	exec "diff --ignore-all-space /var/log/syslog /var/log/messages | grep '^< ' | grep -v CRON";
	exit 0;
}

# extracts required content out of /var/log/messages etc.
my $LOGFILE = "$ARGV[0]";

if (!open(fp, $LOGFILE)) {
	print "Failed to open $LOGFILE\n";
	exit 1;
}

while (<fp>) {
	$line = $_;
	# if the line contains fail or warn, include it in output
	if($line =~ /fail/i || $line =~ /warn/i){
		print $line;
	}
	# if the line contains cron, drop it
	elsif (!($line =~  /cron/)) {
		print $line;
	}
}

close(fp);
