<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

function famc_external_api_manager_validate_credentials(stdClass $manager = NULL, $address = NULL, $username = NULL, $password = NULL) {
  if ($password) { // pre-save
    $credentials = array(
      'address' => trim($address),
      'username' => $username,
      'password' => $password,
    );
  } else {
    $credentials = mercury_management_get_credentials($manager);
  }

  $outArr = array();
  exec("perl /usr/lib/vmware-vcli/apps/general/vcenterdiscover.pl ".
    "--server '" . $credentials['address'] .
    "' --username '" . $credentials['username'] .
    "' --password '" . $credentials['password'] .
    "' --operation vcversion", $outArr);

  // Avoid NOTICE, will hit the u/p invalid block below.
  if (isset($outArr[0])) {
    $vcv = $outArr[0];
  }

  $message = true;
  if (empty($vcv) || stristr($vcv, 'Error')) {
    $message = t('vCenter username or password is invalid.');
  } else if (TRUE !== mercury_utilities_vcenter_version_is_supported($vcv)) {
    $message = t('vCenter version @version is not supported by this version of FMC.', array('@version' => $vcv));
  }

  if ($message !== true) {
    mercury_utilities_fmc_log_message('vCenter Credentials', $message, WATCHDOG_ERROR);
  }
  return $message;
}
