<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

function famc_external_api_vm_validate_credentials(stdClass $vm, $address = NULL, $username = NULL, $password = NULL, $port = NULL) {
  $credentials = mercury_management_get_credentials($vm, $include_ancestors = true);

  // $vm is required for ancestors, but this block is for validating pre-save.
  if ($password) {
    $credentials['address'] = trim($address);
    $credentials['username'] = $username;
    $credentials['password'] = $password;
    $credentials['port'] = $port;
  }

  /* The following is a hack but will work as follows
   * VMrun will output one of the following
   * 1. File exists
   * 2. File doesn't exist
   * 3. Error: Invalid user name or password for the guest OS
   * 4. Error: The virtual machine is not powered on: <path>
   * 5. Error: Cannot open VM: <path>, The virtual machine cannot be found
   * 6.   Unable to connect to host.
   * 		Error: Insufficient permissions in host operating system
   * 7.   Unable to connect to host.
   * 		Error: Failed to resolve host
   */

  $check_vm_username_password = array();
  exec("vmrun -T esx -h https://" . $credentials['vcenter']['address'] .
    "/sdk -u '" . $credentials['vcenter']['username'] .
    "' -p '" . $credentials['vcenter']['password'] .
    "' -gu '" . $credentials['username'] .
    "' -gp '" . $credentials['password'] .
    "' fileExistsInGuest '" . $vm->field_vm_path_name['und'][0]['value'] .
    "' \"C:\Windows\explorer.exe\"", $check_vm_username_password);

  foreach ($check_vm_username_password as $output) {
    if (!empty($output) && stristr($output, 'Error')) {
      if (stristr($output, 'password')) {
        mercury_utilities_fmc_log_message('VM Credentials', t('VM @vm username or password may be incorrect.', array('@vm' => $vm->title)));
        return "Error";
      } else {
        mercury_utilities_fmc_log_message('VM Credentials', t('Cannot connect to VM @vm. Please check if it is powered on and try again.', array('@vm' => $vm->title)));
        return "CannotConnect";
      }
    }
  }
  return true;
}
