<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * @file
 * Bulk export of field_group objects generated by Bulk export module.
 */

/**
 * Implements hook_field_group_info().
 */
function mercury_management_field_group_info() {
  $field_groups = array();

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_device|node|host|form';
  $field_group->group_name = 'group_device';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'host';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'Device',
    'weight' => '42',
    'children' => array(
      0 => 'field_total_size',
      1 => 'field_naa_identifier',
      2 => 'field_allocated_size',
      3 => 'field_device_state',
      4 => 'field_hbtl',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_device|node|host|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_flash_accel_attributes|node|virtual_machine|form';
  $field_group->group_name = 'group_flash_accel_attributes';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'virtual_machine';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'Flash Accel Attributes',
    'weight' => '22',
    'children' => array(
      0 => 'field_fa_build_version',
      1 => 'field_fa_cache_mode',
      2 => 'field_fa_administration_state',
      3 => 'field_fa_cache_size',
      4 => 'field_fa_operational_state',
      5 => 'field_fa_operational_message',
      6 => 'field_fa_performance_state',
      7 => 'field_fa_generation_id',
      8 => 'field_cachespace',
      9 => 'field_fa_usable_blocks',
      10 => 'field_fa_sector_size',
      11 => 'field_fa_metrics_reset_interval',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_flash_accel_attributes|node|virtual_machine|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_flash_accel|node|vdisk|form';
  $field_group->group_name = 'group_flash_accel';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'vdisk';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'Flash Accel Attributes',
    'weight' => '10',
    'children' => array(
      0 => 'field_fa_administration_state',
      1 => 'field_fa_cache_mode',
      2 => 'field_fa_operational_state',
      3 => 'field_fa_operational_message',
      4 => 'field_fa_performance_state',
      5 => 'field_vdisk_identifier',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_flash_accel|node|vdisk|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_metrics|node|vdisk_metrics|form';
  $field_group->group_name = 'group_metrics';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'vdisk_metrics';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'Metrics',
    'weight' => '4',
    'children' => array(
      0 => 'field_vdisk_read_latency',
      1 => 'field_vdisk_write_latency',
      2 => 'field_vdisk_read_ops',
      3 => 'field_vdisk_write_ops',
      4 => 'field_vdisk_hits',
      5 => 'field_vdisk_read_blocks',
      6 => 'field_vdisk_cache_latency',
      7 => 'field_vdisk_population',
      8 => 'field_vdisk_usable_blocks',
      9 => 'field_vdisk_insertions',
      10 => 'field_vdisk_write_blocks',
      11 => 'field_vdisk_population_pc',
      12 => 'field_vdisk_insertion_rate_pc',
      13 => 'field_hit_ops',
      14 => 'field_vdisk_hit_rate_pc',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_metrics|node|vdisk_metrics|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_metrics|node|vm_metrics|form';
  $field_group->group_name = 'group_metrics';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'vm_metrics';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'Metrics',
    'weight' => '4',
    'children' => array(
      0 => 'field_vm_read_latency',
      1 => 'field_vm_write_latency',
      2 => 'field_vm_read_ops',
      3 => 'field_vm_write_ops',
      4 => 'field_vm_hits',
      5 => 'field_vm_read_blocks',
      6 => 'field_vm_cache_latency',
      7 => 'field_vm_population',
      8 => 'field_vm_usable_blocks',
      9 => 'field_vm_write_blocks',
      10 => 'field_vm_insertions',
      11 => 'field_vm_population_pc',
      12 => 'field_vm_insertion_rate_pc',
      13 => 'field_vm_hit_rate_pc',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_metrics|node|vm_metrics|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_vm_reboot|node|virtual_machine|form';
  $field_group->group_name = 'group_vm_reboot';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'virtual_machine';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'VM Reboot',
    'weight' => '21',
    'children' => array(),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_vm_reboot|node|virtual_machine|form'] = $field_group;

  $field_group = new stdClass();
  $field_group->disabled = FALSE; /* Edit this to true to make a default field_group disabled initially */
  $field_group->api_version = 1;
  $field_group->identifier = 'group_vm_vmotion|node|virtual_machine|form';
  $field_group->group_name = 'group_vm_vmotion';
  $field_group->entity_type = 'node';
  $field_group->bundle = 'virtual_machine';
  $field_group->mode = 'form';
  $field_group->parent_name = '';
  $field_group->data = array(
    'label' => 'V Motionable',
    'weight' => '20',
    'children' => array(
      0 => 'field_vm_vmotionable',
      1 => 'field_vm_vmotion_hotlist',
      2 => 'field_vm_vmotion_policy',
      3 => 'field_vm_vmotion_hostlist',
    ),
    'format_type' => 'fieldset',
    'format_settings' => array(
      'formatter' => 'collapsible',
      'instance_settings' => array(
        'description' => '',
        'classes' => '',
        'required_fields' => 1,
      ),
    ),
  );
  $field_groups['group_vm_vmotion|node|virtual_machine|form'] = $field_group;

  return $field_groups;
}
