<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for discovering devices.
 */

/**
 *  Function to return array of devices on a host
 * XXX: This is not used.
 */
function mercury_management_getdevicearray($vc_hostname, $vc_username, $vc_password, $host) {

  $deviceArr = array();
  $validTransportDevices = array();

  exec("esxcli -s " . $vc_hostname . " --username '" . $vc_username . "' --password '" . $vc_password . "' -h '" . $host . "' storage core device list", $dataArr);
  exec("esxcli -s " . $vc_hostname . " --username '" . $vc_username . "' --password '" . $vc_password . "' -h '" . $host . "' storage core path list", $dataPathArr);
  exec("esxcli -s " . $vc_hostname . " --username '" . $vc_username . "' --password '" . $vc_password . "' -h '" . $host . "' system coredump partition list", $diagnosticPartitions);


  /** Devices configured with a diagnostic partition shouldn't be displayed
   * Example output
   * ~ # esxcli system coredump partition list
   * mpx.vmhba32:C0:T0:L0:7  /vmfs/devices/disks/mpx.vmhba32:C0:T0:L0:7    true        true
   */
  foreach ($diagnosticPartitions as $outputLine) {
    if (!empty($outputLine) && stristr($outputLine, 'Error')) {
      break;
    }

    $deviceWithPartitionArr = explode(' ', $outputLine);
    $deviceWithPartition = $deviceWithPartitionArr[0];

    $diagnosticDeviceArr = explode(':', $deviceWithPartition);
    $diagnosticDevice = $diagnosticDeviceArr[0];
    $diagnosticDevices[$diagnosticDevice] = 1;
  }

  foreach ($dataPathArr as $outputLine) {
    if (!empty($outputLine) && stristr($outputLine, 'Device:')) {
      $device_name_split = explode(':', $outputLine);
      if (count($device_name_split) > 1) {
        $device_name = trim($device_name_split[1]);
      }
    } else if (!empty($outputLine) && stristr($outputLine, 'Transport:')) {
      $trasport_type_split = explode(':', $outputLine);
      if (count($trasport_type_split) > 1) {
        $transport_type = trim($trasport_type_split[1]);
        if (!($transport_type == 'usb') && !($transport_type == 'ide') && !($transport_type == 'block') && !($transport_type == 'sata')) {
          $validTransportDevices[$device_name] = 1;
        }
      }
    }
  }

  $validDeviceFlag = 0;
  if (!empty($dataArr)) {
    //$count=0;
    $serial = "";
    foreach ($dataArr as $value) {
      $val_split = explode(':', $value);
      if (count($val_split) > 1) {
        if ($validDeviceFlag == 1) {
          $key = $val_split[0];
          $deviceArr[$serial][trim($val_split[0])] = trim($val_split[1]);
        }
      } else {
        $validDeviceFlag = 0;
        $serial = trim($value);
        if (!empty($serial) && $validTransportDevices[$serial] == 1) {
          $deviceArr[$serial]['serial_no'] = $serial;
          $validDeviceFlag = 1;
# Stubbing this due to the decision to unfix burt 704093.  For now I want
# to make it really easy to add this back in.  If you delete this code,
# please also remove the related code above, the $diagnosticPartitions
# parameter, and fix the places that call here.
#          if (!empty($diagnosticDevices[$serial])) {
#            if ($diagnosticDevices[$serial] == 1) {
#              unset($deviceArr[$serial]);
#              $validDeviceFlag = 0;
#            }
#          }
        }
      }
    }
  }
  return $deviceArr;
}
