<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for discovering vdisks.
 */

function mercury_management_initialize_vdisk_node(&$vDisk_info) {
  $vDisk_info->field_path['und'][0]['value'] = '---';
  $vDisk_info->field_fa_cache_mode['und'][0]['value'] = 'Not Known';
  $vDisk_info->field_fa_administration_state['und'][0]['value'] = 'Not Known';
  $vDisk_info->field_fa_operational_state['und'][0]['value'] = 'Not Known';
  $vDisk_info->field_fa_operational_message['und'][0]['value'] = 'Not Known';
  $vDisk_info->field_fa_performance_state['und'][0]['value'] = 'Not Known';
  $vDisk_info->field_vdisk_identifier['und'][0]['value'] = 'Not Known';
}

/**
 *  Function to return array of vdisks on a VM
 * XXX: This is not used.
 */
function mercury_management_getvdiskarray($vc_hostname, $vc_username, $vc_password, $vmname) {
  $vdiskArr = array();
  $vdiskInfo = exec("perl /usr/lib/vmware-vcli/apps/general/vcenterdiscover.pl  --url https://" . $vc_hostname . "/sdk/vimService --username '" . $vc_username . "' --password '" . $vc_password . "' --vmname '" . $vmname . "'  --operation vdiskinfo | grep Disk", $dataArr);
  if (!empty($dataArr)) {
    //$count=0;
    foreach ($dataArr as $value) {
      $val_split = explode(':', $value);
      if (trim($val_split[1]) == "Not Known") {
        return $vdiskArr;
      }

      // Sample output (note possible spaces and odd characters in VM name):
      // ab-_()+, =.cd Disk[0]: Name : Hard disk 1
      // ab-_()+, =.cd Disk[0]: Type : VMDK
      // ab-_()+, =.cd Disk[0]: Id : naa.6000C2b17f5442b5bcaf0f022c84bc4e
      // ab-_()+, =.cd Disk[0]: Capacity : 85899345920
      // ab-_()+, =.cd Disk[0]: Path : Not Known
      // ab-_()+, =.cd Disk[0]: Freespace : Not Known

      $n = sscanf($value, "$vmname Disk[%[0-9]]: %s : %[^\n]", $disk, $f_name, $f_val);

      if ($n != 3) {
        print " parse failed n=$n disk=$disk f_name=$f_name f_val=$f_val\n";
        continue;
      }

      $f_val = trim($f_val);
      switch ($f_name) {
        case "Path":
          $vdiskArr[$disk]['Path'] = $f_val;
          break;
        case "Name":
          $vdiskArr[$disk]['name'] = $f_val;
          break;
        case "Type":
          $vdiskArr[$disk]['type'] = $f_val;
          break;
        case "Freespace":
          $vdiskArr[$disk]['freespace'] = $f_val;
          break;
        case "Capacity":
          $vdiskArr[$disk]['Capacity'] = $f_val;
          break;
        case "Blocks":
          $vdiskArr[$disk]['Blocks'] = $f_val;
          break;
        case "Blocksize":
          $vdiskArr[$disk]['Blocksize'] = $f_val;
          break;
        case "Id":
          $vdiskArr[$disk]['id'] = $f_val;
          break;
      }
    }
  }
  //print_r($vDiskArr);
  // die();
  return $vdiskArr;
}
