<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */


# This is the path where phpseclib was installed in our instance of Drupal
include DRUPAL_ROOT . '/sites/all/modules/custom/mercury_management/phpseclib/Crypt/AES.php';


class fmc_cipher {

    # This method will encrypt and base-64 encode a string.
    # Base-64 encoding is used since drupal Key/Value and core-variables do not handle binary data well.
    public static function encrypt($plain_text) {
      $cipher = self::get_cipher_obj();
      return ($plain_text? base64_encode($cipher->encrypt($plain_text)): '');
    }

    # This method will base-64 decode and decrypt a string.
    # Base-64 encoding is used since drupal Key/Value and core-variables do not handle binary data well.
    public static function decrypt($cipher_text) {
      $cipher = self::get_cipher_obj();
      return ($cipher_text? $cipher->decrypt(base64_decode($cipher_text)): '');
    }

    # This function instantiates a static cipher object (the object is retreived by the static methods above)
    public static function get_cipher_obj()
    {
        static $cipher = null;
        if ($cipher === null) {
            $cipher = new Crypt_AES(CRYPT_AES_MODE_ECB);

            # Parse the entire config-file
            $fmc_array = parse_ini_file('/etc/flashaccel/fmc.conf');

            # Grab the cipher_key param
            $fmc_cipher_key = $fmc_array['cipher_key'];

            # Set cipher-key and length
            $cipher->setKeyLength(256);
            $cipher->setKey($fmc_cipher_key);
        }

        return $cipher;
    }
}
