<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for bulk actions.
 */

function mercury_utilities_host_bulk_action($action) {
  $output = '';
  $title = '';
  $button_code = '';
  //Check the Avialablity of VIB Package to install/upgrade for Host
  $check_current_vib = trim(variable_get('host_cur_zip'));
  $check_upgrade_vib = trim(variable_get('host_upgraded_zip'));
  $host_package_agent_version = variable_get('host_package_agent_version', '');

  if ($action == "install") {
    if ($check_current_vib != '' && $check_upgrade_vib != '') {
      $title = "Bulk install of host agent version $host_package_agent_version";
      $message = "This will install the Flash Accel host agent to the hosts selected on this page. If you are sure click Install.";
      $button_code = '<div class = "confirm-action"><div class ="bulk-host-install mercury-button bulk-host-button" id=""><span class="mercury-button-model">Install</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
    } else {
      $message = "No Flash Accel Agent Package found. Please use Console Settings > Agents tab to import one, then try again.";
    }
  } elseif ($action == "uninstall") {
    $title = "Bulk uninstall of host agent";
    $message = "This will uninstall the Flash Accel host agent from the hosts selected on this page. If you are sure click Uninstall.";
    $button_code = '<div class = "confirm-action"><div class ="bulk-host-uninstall mercury-button bulk-host-button" id=""><span class = "mercury-button-model">Uninstall</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
  } elseif ($action == "refresh") {
    $title = "Bulk agent refresh";
    $message = "This will refresh the selected Hosts. Please click submit to confirm.";
    $button_code = '<div class = "confirm-action"><div class ="bulk-host-refresh mercury-button bulk-host-button" id=""><span class = "mercury-button-model">Refresh</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
  } elseif ($action == "upgrade") {
    if ($check_current_vib != '' && $check_upgrade_vib != '') {
      $title = "Bulk upgrade to host agent version $host_package_agent_version";
      $message = "This will upgrade the Flash Accel host agent from the hosts selected on this page. If you are sure click Upgrade.";
      $button_code = '<div class = "confirm-action"><div class ="bulk-host-upgrade mercury-button bulk-host-button" id=""><span class = "mercury-button-model">Upgrade</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
    } else {
      $message = "No Flash Accel Agent Package found. Please use Console Settings > Agents tab to import one, then try again.";
    }
  }
  if (!empty($title)) {
    $output .= '<div class = "row-title"><span><strong>' . $title . '</strong></span></div><br>';
  }
  $output .= '<div class = "confirm-message">' . $message . '</div>';
  $output .= $button_code;
  $output .= '</div>';
  return $output;
}

function mercury_utilities_vm_bulk_action($action) {
  $output = '';
  $button_code = '';
  $title = '';

  //Check the Avialablity of MSI Package to install/upgrade for VM
  $check_current_msi = trim(variable_get('vm_cur_MSI'));
  $check_upgrade_msi = trim(variable_get('vm_upgraded_MSI'));
  $vm_package_agent_version = variable_get('vm_package_agent_version', '');

  if ($action == "install") {
    if ($check_current_msi != '' && $check_upgrade_msi != '') {
      $title = "Bulk install of VM agent version $vm_package_agent_version";
      $message = "This will install Flash Accel VM agent on the VMs selected on this page. If you are sure click Install.";
      $button_code = '<div class="res-message red">Note: each selected VM will be shut down automatically during this process. To reboot it instead, check the checkbox below.</div><br><div class = "reboot-check"> Reboot: <input type = "checkbox" name = "vm-reboot-check" value = "vm-reboot-check" class = "vm-reboot-check check"></div>';
      $button_code .= '<div class = "confirm-action"><div class ="bulk-vm-install mercury-button vm-bulk-button" id=""><span class = "mercury-button-model">Install</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
    } else {
      $message = "No Flash Accel Agent Package found. Please use Console Settings > Agents tab to import one, then try again.";
    }
  } elseif ($action == "uninstall") {
    $title = "Bulk uninstall of VM agent";
    $message = "This will uninstall Flash Accel VM Agent from the VMs selected on this page. If you are sure click Uninstall.";
    $button_code = '<div class="res-message red">Note: each selected VM will be rebooted automatically during this process.</div><br><div class = "reboot-check"><input type = "checkbox" name = "vm-reboot-check" value = "vm-reboot-check" class = "vm-reboot-check check" checked = "checked" style="display:none;"></div>';
    $button_code .= '<div class = "confirm-action"><div class ="bulk-vm-uninstall mercury-button vm-bulk-button" id=""><span class = "mercury-button-model">Uninstall</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
  } elseif ($action == "upgrade") {
    if ($check_current_msi != '' && $check_upgrade_msi != '') {
      $title = "Bulk upgrade to VM agent version $vm_package_agent_version";
      $message = "This will upgrade Flash Accel VM Agent on the VMs selected on this page. If you are sure click Upgrade.";
      $button_code = '<div class="res-message red">Note: each selected VM will be shut down automatically during this process. To reboot it instead, check the checkbox below.</div><br><div class = "reboot-check"> Reboot: <input type = "checkbox" name = "vm-reboot-check" value = "vm-reboot-check" class = "upgrade-vm-reboot-check check"></div>';
      $button_code .= '<div class = "confirm-action"><div class ="bulk-vm-upgrade mercury-button vm-bulk-button" id=""><span class = "mercury-button-model">Upgrade</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
    } else {
      $message = "No Flash Accel Agent Package found. Please use Console Settings > Agents tab to import one, then try again.";
    }
  } elseif ($action == "cachemode") {
    $title = "Bulk cache mode update";
    $message = "This will change the cache mode to the value chosen below on all the selected VMs. Please select a mode and submit.";
  } elseif ($action == "cachestate") {
    $title = "Bulk cache state update";
    $message = "This will change the cache state to the value chosen below on all the selected VMs. Please select a state and submit.";
  } elseif ($action == "cachemetrics") {
    $title = "Bulk cache metrics update";
    $message = "This will change the cache metrics state to the value chosen below on all the selected VMs. Please select a state and submit.";
  } elseif ($action == "refresh") {
    $title = "Bulk VM refresh";
    $message = "This will refresh the selected VMs. Please click submit to confirm.";
    $button_code = '<div class = "confirm-action"><div class ="bulk-vm-refresh mercury-button vm-bulk-button" id=""><span class = "mercury-button-model">Refresh</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
  } elseif ($action == "advance") {
    $title = "Bulk cache configuration update";
    $message = "This will change the cache configuration to the values chosen below on all the selected VMs. Please select options and submit.";
  } elseif ($action == "unallocate-cache") {
    $title = "Bulk unacllocate cache";
    $message = "This will unallocate cache from the selected VMs. If you are sure click Unallocate.";
    $button_code = '<div class = "confirm-action"><div class ="bulk-vm-unallocate mercury-button vm-bulk-button" id=""><span class = "mercury-button-model">Unallocate</span></div><div id="vm-status-message" class="operation-message"></div><div class="processing"><img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/processing.gif"/></div></div>';
  } elseif ($action == "allocate-cache") {
    $title = "Bulk acllocate cache update";
    $message = "This will allocate cache to the selected VMs. Please select a size and submit.";
  }
  if (!empty($title)) {
    $output .= '<div class = "row-title"><span><strong>' . $title . '</strong></span></div><br>';
  }
  $output .= '<div class = "confirm-message">' . $message . '</div>';
  if ($action == "install" || $action == "uninstall" || $action == "refresh" || $action == "unallocate-cache" || $action == "upgrade") {
    $output .= $button_code;
  } elseif ($action == "cachemode") {
    $output .= '<div class = "set-cache-mode-form">' . drupal_render(drupal_get_form('mercury_utilities_vm_settings_bulkaction_cachemode_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "cachestate") {
    $output .= '<div class = "set-cache-state-form">' . drupal_render(drupal_get_form('mercury_utilities_vm_settings_bulkaction_cachestate_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "cachemetrics") {
    $output .= '<div class = "set-cache-metrics-form">' . drupal_render(drupal_get_form('mercury_utilities_vm_settings_bulkaction_cachemetrics_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "advance") {
    $output .= '<div class = "set-cache-advance-form">' . drupal_render(drupal_get_form('mercury_utilities_vm_settings_bulkaction_advance_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "allocate-cache") {
    $output .= '<div class = "allocate-cache-form">' . drupal_render(drupal_get_form('mercury_utilities_vm_settings_bulkaction_allocate_cache_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  }
  $output .= '</div>';
  return $output;
}

function mercury_utilities_vm_settings_bulkaction_cachemode_form($form, &$form_state) {
  $form = array();
  $cache_modes = array(0 => t('Write Thru'), 1 => t('Pass Thru'), 2 => t('Write Around'));
  $form['cachemode'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Mode'),
    '#default_value' => 0,
    '#options' => $cache_modes,
    '#description' => t('Select the cache mode.'),
    /* '#access' => $admin, */
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  //$form['vm'] = array(
  //  '#type' => 'hidden',
  //  '#value' => 'vm-3474,3478,+vdisk-3477,3476,',
  //);
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vm_settings_bulkaction_cachemode($cachemode, $ids) {
  //ctools_include('ajax');
  //ctools_include('modal');
  global $base_url;
  if ($cachemode == 0) {
    $cache_mode = "CM_WRITETHRU";
    $modename = "writethru";
  } elseif ($cachemode == 1) {
    $cache_mode = "CM_PASSTHRU";
    $modename = "passthru";
  } elseif ($cachemode == 2) {
    $cache_mode = "CM_WRITEAROUND";
    $modename = "writearound";
  }
  $vm_ids = explode(',', $ids);
  if (sizeof($vm_ids) >= 2) {
    for ($i = 0; $i < sizeof($vm_ids) - 1; $i++) {
      $vm_node = mercury_utilities_node_load_uncached($vm_ids[$i]);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $node_cache_mode = field_get_items('node', $vm_node, 'field_fa_cache_mode');
          if ($node_cache_mode[0]['value'] != $cache_mode) {
            $param = array('request' => array('CacheMode' => $cache_mode));
            $ws_result = mercury_management_cache_operation('nid', $vm_ids[$i], 'HgSetCacheState', $param);
            // mercury_utilities_fmc_log_message('WS called', $vm_ids[$i]);
            if ($ws_result['response_status'] == 'success') {
              $param = array();
              $vm_info = $vm_node;
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode successfully changed on VM @vm.', array('@vm' => $vm_info->title)));
              $attrInfo = mercury_management_cache_operation('nid', $vm_info->nid, 'HgGetCacheInfo', $param);
              if (!empty($attrInfo)) {
                $vm_info->field_fa_build_version['und'][0]['value'] = $attrInfo['build_version'];
                $vm_info->field_fa_cache_mode['und'][0]['value'] = $attrInfo['cache_mode'];
                $vm_info->field_fa_administration_state['und'][0]['value'] = $attrInfo['admin_state'];
                $vm_info->field_fa_cache_size['und'][0]['value'] = $attrInfo['cache_size'];
                $vm_info->field_fa_sector_size['und'][0]['value'] = $attrInfo['sector_size'];
                $vm_info->field_fa_operational_state['und'][0]['value'] = $attrInfo['op_state'];
                $vm_info->field_fa_operational_message['und'][0]['value'] = $attrInfo['op_message'];
                $vm_info->field_fa_performance_state['und'][0]['value'] = $attrInfo['perf_state'];
                if ($attrInfo['cachespace_id'] != '') {
                  $vm_info->field_cachespace['und'][0]['value'] = 'naa.' . $attrInfo['cachespace_id'];
                }
                node_save($vm_info);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Error changing cache mode. Unable to connect to VM agent on VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode is already @mode on VM @vm.', array('@vm' => $vm_node->title, '@mode' => $modename)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Unable to communicate with VM agent. Failed to change cache mode on VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM agent is installed. Failed to change cache mode on VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  }
  if (sizeof($vm_ids) < 2) {
    mercury_utilities_fmc_log_message('Cache Mgmt', 'No VM was selected to change cache mode.', WATCHDOG_WARNING, 'show');
  }
}

function mercury_utilities_vm_settings_bulkaction_cachestate_form($form, &$form_state) {
  $form = array();
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachestate'] = array(
    '#type' => 'radios',
    '#title' => t('Cache State'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache state.'),
    /* '#access' => $admin, */
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vm_settings_bulkaction_cachemetrics_form($form, &$form_state) {
  $form = array();
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachemetrics'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Metrics'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache metric state.'),
    /* '#access' => $admin, */
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vm_settings_bulkaction_cachestate($cachestate, $ids) {
  //ctools_include('ajax');
  //ctools_include('modal');
  global $base_url;
  $cache_state = "ADMIN_ENABLED";
  $statename = "enabled";
  if ($cachestate == 1) {
    $cache_state = "ADMIN_DISABLED";
    $statename = "disabled";
  }
  $vm_ids = explode(',', $ids);
  if (sizeof($vm_ids) >= 2) {
    for ($i = 0; $i < sizeof($vm_ids) - 1; $i++) {
      $vm_node = mercury_utilities_node_load_uncached($vm_ids[$i]);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $node_cache_state = field_get_items('node', $vm_node, 'field_fa_administration_state');
          if ($node_cache_state[0]['value'] != $cache_state) {
            $cache_space = field_get_items('node', $vm_node, 'field_cachespace');
            if ($cache_space[0]['value'] != '') {
              $param = array('request' => array('CacheState' => $cache_state));
              $ws_result = mercury_management_cache_operation('nid', $vm_ids[$i], 'HgSetCacheState', $param);
              if ($ws_result['response_status'] == 'success') {
                $param = array();
                $vm_info = $vm_node;
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache state successfully @cachestate on VM @vm', array('@cachestate' => $statename, '@vm' => $vm_info->title)));
                $attrInfo = mercury_management_cache_operation('nid', $vm_info->nid, 'HgGetCacheInfo', $param);
                if (!empty($attrInfo)) {
                  $vm_info->field_fa_build_version['und'][0]['value'] = $attrInfo['build_version'];
                  $vm_info->field_fa_cache_mode['und'][0]['value'] = $attrInfo['cache_mode'];
                  $vm_info->field_fa_administration_state['und'][0]['value'] = $attrInfo['admin_state'];
                  $vm_info->field_fa_cache_size['und'][0]['value'] = $attrInfo['cache_size'];
                  $vm_info->field_fa_sector_size['und'][0]['value'] = $attrInfo['sector_size'];
                  $vm_info->field_fa_operational_state['und'][0]['value'] = $attrInfo['op_state'];
                  $vm_info->field_fa_operational_message['und'][0]['value'] = $attrInfo['op_message'];
                  $vm_info->field_fa_performance_state['und'][0]['value'] = $attrInfo['perf_state'];
                  if ($attrInfo['cachespace_id'] != '') {
                    $vm_info->field_cachespace['und'][0]['value'] = 'naa.' . $attrInfo['cachespace_id'];
                  }
                  node_save($vm_info);
                }
              } else {
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Error during bulk action cache state change operation on VM @vm', array('@vm' => $vm_node->title)), WATCHDOG_ERROR);
                if ($cache_state == "ADMIN_ENABLED") {
                  mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
                  mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
                }
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Allocate Cache Space first to perform this action.'), WATCHDOG_WARNING);
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache is already @cache_state on VM @vm', array('@cache_state' => $statename, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache cannot be @cache_state as VM @vm is not reachable.', array('@cache_state' => $statename, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache state cannot be changed. VM agent is not installed on VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  }
  if (sizeof($vm_ids) < 2) {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM was selected to perform a cache state change operation.'), WATCHDOG_WARNING, 'show');
  }
  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vm_settings_bulkaction_cachemetrics($cachestate, $ids) {
  global $base_url;
  //ctools_include('ajax');
  //ctools_include('modal');
  if ($cachestate == 0) {
    $cache_state = "ADMIN_ENABLED";
    $statename = "enabled";
  } elseif ($cachestate == 1) {
    $cache_state = "ADMIN_DISABLED";
    $statename = "disabled";
  }
  $vm_ids = explode(',', $ids);
  if (sizeof($vm_ids) >= 2) {
    for ($i = 0; $i < sizeof($vm_ids) - 1; $i++) {
      $vm_node = mercury_utilities_node_load_uncached($vm_ids[$i]);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $node_cache_state = field_get_items('node', $vm_node, 'field_fa_performance_state');
          if ($node_cache_state[0]['value'] != $cache_state) {
            $param = array('request' => array('PerfState' => $cache_state));
            $ws_result = mercury_management_cache_operation('nid', $vm_ids[$i], 'HgSetCacheState', $param);
            // mercury_utilities_fmc_log_message('WS called', $vm_ids[$i]);
            if ($ws_result['response_status'] == 'success') {
              $param = array();
              $vm_info = $vm_node;
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics successfully @cachestate on VM @vm', array('@cachestate' => $statename, '@vm' => $vm_info->title)));
              $attrInfo = mercury_management_cache_operation('nid', $vm_info->nid, 'HgGetCacheInfo', $param);
              if (!empty($attrInfo)) {
                $vm_info->field_fa_build_version['und'][0]['value'] = $attrInfo['build_version'];
                $vm_info->field_fa_cache_mode['und'][0]['value'] = $attrInfo['cache_mode'];
                $vm_info->field_fa_administration_state['und'][0]['value'] = $attrInfo['admin_state'];
                $vm_info->field_fa_cache_size['und'][0]['value'] = $attrInfo['cache_size'];
                $vm_info->field_fa_sector_size['und'][0]['value'] = $attrInfo['sector_size'];
                $vm_info->field_fa_operational_state['und'][0]['value'] = $attrInfo['op_state'];
                $vm_info->field_fa_operational_message['und'][0]['value'] = $attrInfo['op_message'];
                $vm_info->field_fa_performance_state['und'][0]['value'] = $attrInfo['perf_state'];
                if ($attrInfo['cachespace_id'] != '') {
                  $vm_info->field_cachespace['und'][0]['value'] = 'naa.' . $attrInfo['cachespace_id'];
                }
                node_save($vm_info);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics cannot be changed as VM agent is not reachable on @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics are already @cache_state on VM @vm', array('@cache_state' => $statename, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics cannot be @cache_state as the VM @vm is not reachable.', array('@cache_state' => $statename, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics cannot be @cache_state as a VM agent is not installed on @vm.', array('@cache_state' => $statename, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  }
  if (sizeof($vm_ids) < 2) {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM was selected for changing cache metrics state.'), WATCHDOG_WARNING, 'show');
  }
  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vdisk_bulk_action($action) {
  $output = '';
  if ($action == "cachemode") {
    $message = "This will change the cache mode to the value chosen below for all selected VM disks.  Please choose a mode and submit.";
    $form = '<div class = "set-disk-cache-mode-form">' . drupal_render(drupal_get_form('mercury_utilities_vdisk_settings_bulkaction_cachemode_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "cachestate") {
    $message = "This will change the cache state to the value chosen below for all selected VM disks.  Please choose a state and submit.";
    $form = '<div class = "set-disk-cache-state-form">' . drupal_render(drupal_get_form('mercury_utilities_vdisk_settings_bulkaction_cachestate_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "cachemetrics") {
    $message = "This will change the cache metrics state to the value chosen below for all selected VM disks.  Please choose a state and submit.";
    $form = '<div class = "set-disk-cache-metrics-form">' . drupal_render(drupal_get_form('mercury_utilities_vdisk_settings_bulkaction_cachemetrics_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  } elseif ($action == "advance") {
    $message = "This will change the cache values to the value chosen below for all selected VM disks.  Please choose a state and submit.";
    $form = '<div class = "set-disk-advance-form">' . drupal_render(drupal_get_form('mercury_utilities_vdisk_settings_bulkaction_advance_form')) . '<div class="processing"><img src=" /sites/all/modules/custom/mercury_utilities/images/processing.gif"></div></div>';
  }
  $output .= '<div class = "confirm-message">' . $message . '</div>';
  $output .= $form;
  return $output;
}

function mercury_utilities_vdisk_settings_bulkaction_cachemode_form($form, &$form_state) {
  $form = array();
  $cache_modes = array(0 => t('Write Thru'), 1 => t('Pass Thru'), 2 => t('Write Around'));
  $form['cachemode'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Mode'),
    '#default_value' => 0,
    '#options' => $cache_modes,
    '#description' => t('Select the cache mode.'),
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vdisk_settings_bulkaction_cachestate_form($form, &$form_state) {
  $form = array();
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachestate'] = array(
    '#type' => 'radios',
    '#title' => t('Cache State'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache state.'),
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vdisk_settings_bulkaction_cachemetrics_form($form, &$form_state) {
  $form = array();
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachemetrics'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Metrics'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache metric state.'),
  );
  $form['vm_ids'] = array(
    '#type' => 'textfield',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vdisk_settings_bulkaction_advance_form($form, &$form_state) {
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $cache_modes = array(0 => t('Write Thru'), 1 => t('Pass Thru'), 2 => t('Write Around'));
  $perf_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachestate'] = array(
    '#type' => 'radios',
    '#title' => t('Cache State'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache state.'),
  );
  $form['cachemode'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Mode'),
    '#default_value' => 0,
    '#options' => $cache_modes,
    '#description' => t('Select the cache mode.'),
  );
  $form['perfstate'] = array(
    '#type' => 'radios',
    '#title' => t('Metrics'),
    '#default_value' => 0,
    '#options' => $perf_states,
    '#description' => t('Select the cache metric state.'),
  );
  $form['vdisk_id'] = array(
    '#type' => 'hidden',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vdisk_settings_bulkaction_cachemode($cachemode, $ids) {
  global $base_url;
  if ($cachemode == 0) {
    $cache_mode = "CM_WRITETHRU";
    $modename = "writethru";
  } elseif ($cachemode == 1) {
    $cache_mode = "CM_PASSTHRU";
    $modename = "passthru";
  } elseif ($cachemode == 2) {
    $cache_mode = "CM_WRITEAROUND";
    $modename = "writearound";
  }
  $vdisk_ids = explode(',', $ids);
  if (sizeof($vdisk_ids) >= 2) {
    for ($j = 0; $j < sizeof($vdisk_ids) - 1; $j++) {
      $vdisk_node = mercury_utilities_node_load_uncached($vdisk_ids[$j]);
      $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
      $vdisk_vm_id = $vdisk_vm[0]['target_id'];
      $vm_node = mercury_utilities_node_load_uncached($vdisk_vm_id);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $params = new stdClass();
          $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
          $disk_num = field_get_items('node', $vdisk_node, 'field_disk_index');
          $vdisk_identifier_value = $vdisk_identifier[0]['value'];
          $identifier = field_get_items('node', $vdisk_node, 'field_vdisk_id');
          $disk_path_value = $identifier[0]['value'];
          $disk_num_value = $disk_num[0]['value'];
          $node_cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
          if ($node_cache_mode[0]['value'] != $cache_mode) {
            $params->DeviceStateRequest['0'] = array('CacheMode' => $cache_mode, 'NaaId' => $vdisk_identifier_value);
            $disk_param = array('request' => $params);
            $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgSetDeviceState', $disk_param);
            if ($vdisk_result['response_status'] == 'success') {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode changed successfully for vDisk @vdisk', array('@vdisk' => $vdisk_node->title)));
              $param = array();
              $vdisk_identifier = explode('.', $disk_path_value);
              $vdisk_identifier_value = strtolower(trim($vdisk_identifier[1]));

              # Send request to read the cache information back and update
              $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
              if ($attrInfo != 'error_wsdl_call') {
                $diskCount = $attrInfo['disk_count'];
                for ($index = 0; $index < $diskCount; $index++) {
                  # compare against current disk
                  $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
                  if ($identifier == $vdisk_identifier_value) {
                    $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
                    $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
                    $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
                    $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
                    $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
                    node_save($vdisk_node);
                    break;
                  }
                }
              } else {
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode changed to @mode for @vdisk. Please refresh VM @vm to view change.', array('@mode' => $modename, '@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Failed to change cache mode for @vdisk. Unable to communicate with VM agent on VM @vm.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode is already set to @cache_mode mode on vDisk @vdisk', array('@cache_mode' => $modename, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode cannot be changed for vDisk @vdisk as VM @vm is not reachable.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message(t('Cache mode cannot be changed for vDisk @vdisk. No VM agent is installed on VM @vm.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No vDisk was selected to change cache mode.'), WATCHDOG_WARNING, 'show');
  }
//  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vdisk_settings_bulkaction_cachestate($cachestate, $ids) {
  global $base_url;
  $cache_state = "ADMIN_ENABLED";
  $statename = "enabled";
  if ($cachestate == 1) {
    $cache_state = "ADMIN_DISABLED";
    $statename = "disabled";
  }
  $vdisk_ids = explode(',', $ids);
  if (sizeof($vdisk_ids) >= 2) {
    for ($j = 0; $j < sizeof($vdisk_ids) - 1; $j++) {
      $vdisk_node = mercury_utilities_node_load_uncached($vdisk_ids[$j]);
      $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
      $vdisk_vm_id = $vdisk_vm[0]['target_id'];
      $vm_node = mercury_utilities_node_load_uncached($vdisk_vm_id);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $params = new stdClass();
          $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
          $disk_num = field_get_items('node', $vdisk_node, 'field_disk_index');
          $vdisk_identifier_value = $vdisk_identifier[0]['value'];
          //$disk_path = field_get_items('node', $vdisk_node, 'field_path');
          $identifier = field_get_items('node', $vdisk_node, 'field_vdisk_id');
          $disk_path_value = $identifier[0]['value'];
          $disk_num_value = $disk_num[0]['value'];
          $node_cache_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
          if ($node_cache_state[0]['value'] != $cache_state) {
            $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'NaaId' => $vdisk_identifier_value);
            $disk_param = array('request' => $params);
            $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgSetDeviceState', $disk_param);
            if ($vdisk_result['response_status'] == 'success') {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache @cachestate for vDisk @vdisk', array('@cachestate' => $statename, '@vdisk' => $vdisk_node->title)));
              $param = array();
              $vdisk_identifier = explode('.', $disk_path_value);
              $vdisk_identifier_value = strtolower(trim($vdisk_identifier[1]));

              # Send request to read the cache information back and update
              $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
              if ($attrInfo != 'error_wsdl_call') {
                $diskCount = $attrInfo['disk_count'];
                for ($index = 0; $index < $diskCount; $index++) {
                  # compare against current disk
                  $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
                  if ($identifier == $vdisk_identifier_value) {
                    $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
                    $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
                    $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
                    $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
                    $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
                    node_save($vdisk_node);
                    break;
                  }
                }
              } else {
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache @cache_state for vDisk @vdisk. Please refresh the VM to view change.', array('@cache_state' => $statename, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Unable to communicate with VM agent. Cannot change cache state for vDisk @vdisk on VM @vm', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
              if ($cache_state == "ADMIN_ENABLED") {
                mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
                mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
              }
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache state is already @cache_state for vDisk @vdisk', array('@cache_state' => $statename, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache state cannot be @cache_state for vDisk @vdisk as VM @vm is not reachanble.', array('@cache_state' => $statename, '@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache state cannot be changed on vDisk @vdisk as a VM agent is not installed on VM @vm.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No vDisk was selected to perform a cache state change operation.'), WATCHDOG_WARNING, 'show');
  }
  // drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vdisk_settings_bulkaction_cachemetrics($metricstate, $ids) {
  global $base_url;
  if ($metricstate == 0) {
    $cache_state = "ADMIN_ENABLED";
    $statename = "enabled";
  } elseif ($metricstate == 1) {
    $cache_state = "ADMIN_DISABLED";
    $statename = "disabled";
  }
  $vdisk_ids = explode(',', $ids);
  if (sizeof($vdisk_ids) >= 2) {
    for ($j = 0; $j < sizeof($vdisk_ids) - 1; $j++) {
      $vdisk_node = mercury_utilities_node_load_uncached($vdisk_ids[$j]);
      $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
      $vdisk_vm_id = $vdisk_vm[0]['target_id'];
      $vm_node = mercury_utilities_node_load_uncached($vdisk_vm_id);
      $node_driver_status = field_get_items('node', $vm_node, 'field_driver_status');
      if ($node_driver_status[0]['value'] == "Agent Installed") {
        $node_hostname = field_get_items('node', $vm_node, 'field_vm_hostname');
        if ($node_hostname[0]['value'] != "Not Known" || $node_hostname[0]['value'] != '' || $node_hostname[0]['value'] != "No Hostname") {
          $params = new stdClass();
          $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
          $disk_num = field_get_items('node', $vdisk_node, 'field_disk_index');
          $vdisk_identifier_value = $vdisk_identifier[0]['value'];
          //$disk_path = field_get_items('node', $vdisk_node, 'field_path');
          $identifier = field_get_items('node', $vdisk_node, 'field_vdisk_id');
          $disk_path_value = $identifier[0]['value'];
          $disk_num_value = $disk_num[0]['value'];
          $node_cache_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');
          if ($node_cache_state[0]['value'] != $cache_state) {
            $params->DeviceStateRequest['0'] = array('PerfState' => $cache_state, 'NaaId' => $vdisk_identifier_value);
            $disk_param = array('request' => $params);
            $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgSetDeviceState', $disk_param);
            if ($vdisk_result['response_status'] == 'success') {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics @cachestate on @vdisk', array('@cachestate' => $statename, '@vdisk' => $vdisk_node->title)));
              $param = array();
              $vdisk_identifier = explode('.', $disk_path_value);
              $vdisk_identifier_value = strtolower(trim($vdisk_identifier[1]));

              # Send request to read the cache information back and update
              $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
              if ($attrInfo != 'error_wsdl_call') {
                $diskCount = $attrInfo['disk_count'];
                for ($index = 0; $index < $diskCount; $index++) {
                  # compare against current disk
                  $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
                  if ($identifier == $vdisk_identifier_value) {
                    $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
                    $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
                    $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
                    $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
                    $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
                    node_save($vdisk_node);
                    break;
                  }
                }
              } else {
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics @cachestate for vDisk @vdisk. Please refresh the VM to view change.', array('@cachestate' => $statename, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics could not be @cachestate for vDisk @vdisk.', array('@cachestate' => $statename, '@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics are already @cache_state for vDisk @vdisk', array('@cache_state' => $statename, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics could not be changed for vDisk @vdisk as VM @vm is not reachable.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache metrics could not be changed for vDisk @vdisk as VM agent is not installed on @vm.', array('@vdisk' => $vdisk_node->title, '@vm' => $vm_node->title)), WATCHDOG_WARNING);
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No vDisk was selected for changing cache metrics state.'), WATCHDOG_WARNING, 'show');
  }
  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vdisk_settings_bulkaction_advance($param, $ids) {
  $vdisk_ids = explode(',', $ids);
  $options = explode('-', $param);
  if (sizeof($vdisk_ids) >= 2) {
    for ($j = 0; $j < sizeof($vdisk_ids) - 1; $j++) {
      $vdisk_id = $vdisk_ids[$j];
      $vdisk_node = node_load($vdisk_id);
      $node_perf_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');
      $node_cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
      $node_cache_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
      $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
      $vdisk_identifier_value = $vdisk_identifier[0]['value'];
      $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
      $vdisk_vm_id = $vdisk_vm[0]['target_id'];
      $vm_node = node_load($vdisk_vm_id);
      $selected_cache_state = $options[0];
      $selected_cache_mode = $options[1];
      $selected_perf_state = $options[2];
      $no_action = 0;
      if ($selected_cache_state == 0) {
        $cache_state = "ADMIN_ENABLED";
      } elseif ($selected_cache_state == 1) {
        $cache_state = "ADMIN_DISABLED";
      }
      if ($selected_cache_mode == 0) {
        $cache_mode = "CM_WRITETHRU";
      } elseif ($selected_cache_mode == 1) {
        $cache_mode = "CM_PASSTHRU";
      } elseif ($selected_cache_mode == 2) {
        $cache_mode = "CM_WRITEAROUND";
      }
      if ($selected_perf_state == 0) {
        $perf_state = "ADMIN_ENABLED";
      } elseif ($selected_perf_state == 1) {
        $perf_state = "ADMIN_DISABLED";
      }
      if ($node_cache_state[0]['value'] != $cache_state) {
        $cache_state_flag = 1;
      } else {
        $cache_state_flag = 0;
      }
      if ($node_cache_mode[0]['value'] != $cache_mode) {
        $cache_mode_flag = 1;
      } else {
        $cache_mode_flag = 0;
      }
      if ($node_perf_state[0]['value'] != $perf_state) {
        $perf_state_flag = 1;
      } else {
        $perf_state_flag = 0;
      }
      // XXX: Accidental assignment.  Fix this in Copper.
      // Fortunately it accidentally works OK, in that the assignment
      // is not an important var and it just results in sending too many params.
      if ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
        $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'CacheMode' => $cache_mode, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
        $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'CacheMode' => $cache_mode, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
        $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 0) {
        $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
        $params->DeviceStateRequest['0'] = array('CacheMode' => $cache_mode, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
        $params->DeviceStateRequest['0'] = array('CacheMode' => $cache_mode, 'NaaId' => $vdisk_identifier_value);
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
        $params->DeviceStateRequest['0'] = array('PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
      } else {
        $no_action = 1;
      }
      if ($no_action == 0) {
        # Send the web service request
        $disk_param = array('request' => $params);
        $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgSetDeviceState', $disk_param);
        if ($vdisk_result == 'error_wsdl_call') {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM @vm. Please refresh VM and try again.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
          if ($cache_state == "ADMIN_ENABLED") {
            mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
            mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
          }
        } elseif ($vdisk_result['response_status'] == 'success') {
          # Space for success message for action success.
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache advance operation successful on VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_NOTICE, 'show');
          # Send request to read the cache information back and update
          $param = array();
          $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
          if ($attrInfo != 'error_wsdl_call') {
            $diskCount = $attrInfo['disk_count'];
            for ($index = 0; $index < $diskCount; $index++) {
              # compare against current disk
              $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
              if ($identifier == $vdisk_identifier_value) {
                $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
                $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
                $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
                $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
                $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
                node_save($vdisk_node);
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Node @node_title update successful.', array('@node_title' => $vdisk_node->title)), WATCHDOG_NOTICE, 'show');
              }
            }
          } else {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Node @node_title update failed.', array('@node_title' => $vdisk_node->title)), WATCHDOG_NOTICE, 'show');
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM. Please refresh VM and try again.'), WATCHDOG_ERROR);
          if ($cache_state == "ADMIN_ENABLED") {
            mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
            mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
          }
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('No vDisk Cache changes were performed.'), WATCHDOG_WARNING, 'show');
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No vDisk was selected for changing cache metrics state.'), WATCHDOG_WARNING, 'show');
  }
  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

function mercury_utilities_vm_settings_bulkaction_advance_form($form, &$form_state) {
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $cache_modes = array(0 => t('Write Thru'), 1 => t('Pass Thru'), 2 => t('Write Around'));
  $perf_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachestate'] = array(
    '#type' => 'radios',
    '#title' => t('Cache State'),
    '#default_value' => 0,
    '#options' => $cache_states,
    '#description' => t('Select the cache state.'),
  );
  $form['cachemode'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Mode'),
    '#default_value' => 0,
    '#options' => $cache_modes,
    '#description' => t('Select the cache mode.'),
  );
  $form['perfstate'] = array(
    '#type' => 'radios',
    '#title' => t('Metrics'),
    '#default_value' => 0,
    '#options' => $perf_states,
    '#description' => t('Select the cache metric state.'),
  );
  $form['vm_id'] = array(
    '#type' => 'hidden',
    '#value' => 'test',
    '#attributes' => array('class' => array('ws-ids'))
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vm_settings_bulkaction_advance($param, $ids) {
  $vm_ids = explode(',', $ids);
  $options = explode('-', $param);
  if (sizeof($vm_ids) >= 2) {
    for ($j = 0; $j < sizeof($vm_ids) - 1; $j++) {
      $vm_id = $vm_ids[$j];
      $vm_node = node_load($vm_id);
      $node_perf_state = field_get_items('node', $vm_node, 'field_fa_performance_state');
      $node_cache_mode = field_get_items('node', $vm_node, 'field_fa_cache_mode');
      $node_cache_state = field_get_items('node', $vm_node, 'field_fa_administration_state');
      $selected_cache_state = $options[0];
      $selected_cache_mode = $options[1];
      $selected_perf_state = $options[2];
      $no_action = 0;
      if ($selected_cache_state == 0) {
        $cache_state = "ADMIN_ENABLED";
      } elseif ($selected_cache_state == 1) {
        $cache_state = "ADMIN_DISABLED";
      }
      if ($selected_cache_mode == 0) {
        $cache_mode = "CM_WRITETHRU";
      } elseif ($selected_cache_mode == 1) {
        $cache_mode = "CM_PASSTHRU";
      } elseif ($selected_cache_mode == 2) {
        $cache_mode = "CM_WRITEAROUND";
      }
      if ($selected_perf_state == 0) {
        $perf_state = "ADMIN_ENABLED";
      } elseif ($selected_perf_state == 1) {
        $perf_state = "ADMIN_DISABLED";
      }
      if ($node_cache_state[0]['value'] != $cache_state) {
        $cache_state_flag = 1;
      } else {
        $cache_state_flag = 0;
      }
      if ($node_cache_mode[0]['value'] != $cache_mode) {
        $cache_mode_flag = 1;
      } else {
        $cache_mode_flag = 0;
      }
      if ($node_perf_state[0]['value'] != $perf_state) {
        $perf_state_flag = 1;
      } else {
        $perf_state_flag = 0;
      }
      // XXX: Accidental assignment.  Fix this in Copper.
      // Fortunately it accidentally works OK, in that the assignment
      // is not an important var and it just results in sending too many params.
      if ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
        $params = array('request' => array('CacheMode' => $cache_mode, 'CacheState' => $cache_state, 'PerfState' => $perf_state));
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
        $params = array('request' => array('CacheMode' => $cache_mode, 'CacheState' => $cache_state));
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
        $params = array('request' => array('CacheState' => $cache_state, 'PerfState' => $perf_state));
      } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 0) {
        $params = array('request' => array('CacheState' => $cache_state));
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
        $params = array('request' => array('CacheMode' => $cache_mode, 'PerfState' => $perf_state));
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
        $params = array('request' => array('CacheMode' => $cache_mode));
      } elseif ($cache_state_flag = 0 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
        $params = array('request' => array('PerfState' => $perf_state));
      } else {
        $no_action = 1;
      }
      if ($no_action == 0) {
        # Send the web service request
        $ws_result = mercury_management_cache_operation('nid', $vm_id, 'HgSetCacheState', $params);
        if ($ws_result == 'error_wsdl_call') {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Error reconfiguring cache on VM "@vm". VM agent communication error.', array('@vm' => $vm_node->title)), WATCHDOG_ERROR);
          if ($cache_state == "ADMIN_ENABLED") {
            mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
            mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
          }
        } elseif ($ws_result['response_status'] == 'success') {
          $null_param = array();
          $vm_info = node_load($vm_id);
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfigured successfully on VM @vm', array('@vm' => $vm_info->title)));
          $attrInfo = mercury_management_cache_operation('nid', $vm_info->nid, 'HgGetCacheInfo', $null_param);
          //mercury_utilities_fmc_log_message('attrInfo', $attrInfo);
          if (!empty($attrInfo)) {
            $vm_info->field_fa_build_version['und'][0]['value'] = $attrInfo['build_version'];
            $vm_info->field_fa_cache_mode['und'][0]['value'] = $attrInfo['cache_mode'];
            $vm_info->field_fa_administration_state['und'][0]['value'] = $attrInfo['admin_state'];
            $vm_info->field_fa_cache_size['und'][0]['value'] = $attrInfo['cache_size'];
            $vm_info->field_fa_sector_size['und'][0]['value'] = $attrInfo['sector_size'];
            $vm_info->field_fa_operational_state['und'][0]['value'] = $attrInfo['op_state'];
            $vm_info->field_fa_operational_message['und'][0]['value'] = $attrInfo['op_message'];
            $vm_info->field_fa_performance_state['und'][0]['value'] = $attrInfo['perf_state'];
            if ($attrInfo['cachespace_id'] != '') {
              $vm_info->field_cachespace['und'][0]['value'] = 'naa.' . $attrInfo['cachespace_id'];
            }
            node_save($vm_info);
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM @vm. Please refresh VM and try again.', array('@vm' => $vm_info->title)), WATCHDOG_ERROR);
          if ($cache_state == "ADMIN_ENABLED") {
            mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
            mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
          }
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM cache changes were performed.'), WATCHDOG_WARNING, 'show');
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM was selected for advance setting.'), WATCHDOG_WARNING, 'show');
  }
  drupal_add_js('jQuery(".proceesing").css("display", "none");', 'inline');
}

/**
 * Function for calling the refresh function for bulk vm
 */
function mercury_utilities_vm_bulk_refresh_action($vm_ids) {
  if ($vm_ids != 0) {
    $vm_id = explode(',', $vm_ids);
    if (sizeof($vm_id) > 1) {
      for ($i = 0; $i < sizeof($vm_id) - 1; $i++) {
        mercury_utilities_vm_refresh_action($vm_id[$i], "no_refresh");
      }
    }
  } else {
    mercury_utilities_fmc_log_message('VM Refresh', t('No VM selected to perform Refresh operation.'), WATCHDOG_WARNING);
  }
  drupal_goto($_SERVER['HTTP_REFERER']);
}

/**
 * Function for calling the refresh function for bulk Host
 */
function mercury_utilities_host_bulk_refresh_action($host_ids) {
  if ($host_ids != 0) {
    $host_id = explode(',', $host_ids);
    if (sizeof($host_id) > 1) {
      for ($i = 0; $i < sizeof($host_id) - 1; $i++) {
        mercury_utilities_host_refresh_action($host_id[$i], "no_refresh");
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Host Refresh', t('No Host selected to perform Refresh operation.'), WATCHDOG_WARNING);
  }
  drupal_goto($_SERVER['HTTP_REFERER']);
}

/**
 * Function for calling the refresh function for bulk vm
 */
function mercury_utilities_vm_bulk_unallocate_action($vm_ids) {
  if ($vm_ids != 0) {
    $vm_id = explode(',', $vm_ids);
    if (sizeof($vm_id) > 1) {
      for ($i = 0; $i < sizeof($vm_id) - 1; $i++) {
        $vm_node = node_load($vm_id[$i]);
        $cache_space = field_get_items('node', $vm_node, 'field_cachespace');
        $admin_state = field_get_items('node', $vm_node, 'field_fa_administration_state');
        if ($cache_space[0]['value'] == '') {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('No cache has been allocated to the VM @vm.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
        } else {
          if ($admin_state[0]['value'] == "ADMIN_ENABLED") {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache is currently enabled on VM @vm. Please disable the cache before unallocating the cache space.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
          } else {
            mercury_utilities_vm_settings_cachespace('bulk-unallocate', $vm_id[$i]);
          }
        }
      }
    }
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM selected to perform Unallocate operation.'), WATCHDOG_WARNING);
  }
  drupal_goto($_SERVER['HTTP_REFERER']);
}

/**
 * Function for calling the allocate function for bulk vm
 * @deprecated not used and so very out of date
 */
function mercury_utilities_vm_settings_bulkaction_allocate_cache_form($form, &$form_state) {
  /* This function will return host id of the host having minimum cache space among the available host */
  $host_nid = mercury_utilities_vm_settings_bulkaction_minimum_size_host();
  $host_node = node_load($host_nid);

  //Allocate the Minimum Cache Space available  Host
  $available_segments = mercury_management_get_all_host_data('host_cache', $host_nid);

  //Get the Minimum Cache Space setting value for a VM (in GB)
  $cache_space_settings_value = variable_get('minimum_cache_space_vm', 1024);

  if (($available_segments * 256) - ($cache_space_settings_value * 1024) < 0) {
    $form['item'] = array(
      '#type' => 'markup',
      '#markup' => '<div class="messages warning">There is not enough space available on the host flash device to allocate a cache space.  This may be because no flash device has been assigned to this host yet, or because the assigned flash device does not contain required free space.</div>',
    );
  } else {
    $form['item_1'] = array(
      '#type' => 'markup',
      '#markup' => '<div id="cache_error_mesg"></div>',
      '#suffix' => '<script>
        jQuery("#edit-submit").live("click", function() {
          jQuery("#edit-submit").hide();
          jQuery(".form-item-num-segments-manually").hide();
          jQuery(".form-item-manually-allocate-segments").hide();
          jQuery("a.close").hide();
          jQuery(".processing").show();
          jQuery(".transfer-slider").hide();
          jQuery("div.res-message").remove();
          jQuery("#warning-message").append( \'<div class="res-message red">Please do not close the browser window until the process completes.</div>\');
          jQuery("#warning-message").append(\'<div class="res-message">Allocating Cache Space...</div>\');
        });
        if (jQuery("#modal-content .error").length > 0) {
          var error_mesg = jQuery("#modal-content .error").html();
          if (error_mesg.length > 1 ){
            jQuery("a.close").show();
            jQuery("div.res-message").remove();
          }
          jQuery("#edit-submit").show();
          jQuery("#edit-num-segments-manually").removeAttr("checked");
		    }
		  </script>',
    );
    $form['item_2'] = array(
      '#type' => 'markup',
      '#markup' => '<div id = "warning-message">' . t('Please use the slider to allocate cache space or enter a value by selecting \'Enter Manually\'.<br/> You can allocate a minimum of ' . $cache_space_settings_value * 1024 . ' MB and a maximum of ' . $available_segments * 256 . ' MB') . '</div>',
    );

    $form['num_segments_manually'] = array(
      '#type' => 'checkbox',
      '#title' => t('Enter Manually'),
      '#size' => 10,
      '#attributes' => array('id' => 'edit-num-segments-manually')
    );

    $form['num_segments'] = array(
      '#type' => 'transfer_slider',
      '#title' => t('Size'),
      '#left_value' => $cache_space_settings_value * 1024, //256,
      '#right_value' => ($available_segments * 256) - ($cache_space_settings_value * 1024), // Slider uses max: ($left + $right)
      '#left' => t('MB Allocated'),
      '#right' => t('MB Left'),
      '#suffix' => '<script>
                    jQuery(".form-item-manually-allocate-segments").hide();
                    jQuery("#edit-num-segments-left").attr("readonly","readonly");
                    jQuery("#edit-num-segments-right").attr("readonly","readonly");
                    jQuery("#edit-num-segments-manually").click(function () {
                      if (jQuery("#edit-num-segments-manually").is(":checked")) {
                        jQuery(".form-item-manually-allocate-segments").show();
                        jQuery(".transfer-slider.container-inline").hide();
                      } else {
                        jQuery(".form-item-manually-allocate-segments").hide();
                        jQuery(".transfer-slider.container-inline").show();
                      }
                      jQuery("#edit-manually-allocate-segments").val("");
                    });
                  </script>'
    );

    $form['manually_allocate_segments'] = array(
      '#type' => 'textfield',
      '#title' => t('Enter Cache Space Size'),
      '#description' => t('Enter Cache Space size value in MB'),
      '#size' => 10,
      '#attributes' => array('id' => 'edit-manually-allocate-segments')
    );
    $form['vm_ids'] = array(
      '#type' => 'hidden',
      '#value' => 'test',
      '#attributes' => array('class' => array('ws-ids')),
    );
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Allocate'),
      '#prefix' => '<br><br>',
      '#attributes' => array('id' => 'edit-submit'),
    );
  }
  return $form;
}

/**
 * @deprecated not used, out of date, terrible function name.
 */
function mercury_utilities_vm_settings_bulkaction_minimum_size_host() {
  $min_nid = array();
  $host_min_nid = '';
  $host_query = db_select('node', 'node');
  $host_query->fields('node', array('nid'));
  $host_query->condition('node.status', 1)
    ->condition('node.type', 'host');
  $host_result = $host_query->orderBy('node.title', 'DESC')
    ->execute();
  while ($host_row = $host_result->fetch()) {
    $host_node = node_load($host_row->nid);
    $bundle_status = field_get_items('node', $host_node, 'field_bundle_status');
    $naa_identifier = field_get_items('node', $host_node, 'field_naa_identifier');
    if ($bundle_status[0]['value'] == "Agent Installed" && $naa_identifier[0]['value'] != '') {
      $available_segments = mercury_management_get_all_host_data('host_cache', $host_row->nid);
      $min_nid[$available_segments] = $host_row->nid;
    }
  }
  ksort($min_nid);
  foreach ($min_nid as $key => $val) {
    $host_min_nid = $val;
    break;
  }
  return $host_min_nid;
}

/**
 * @deprecated There is no sidebar link for bulk allocate.
 * For this to be used again, it will have to catch up with single allocate.
 * That includes the new rules for VMFS-3 and >2TB allocations.
 */
function mercury_utilities_vm_settings_bulkaction_allocate_cache_action($num_segment, $vm_ids) {
  $vm_id_data = explode(',', $vm_ids);

  if (count($vm_id_data) > 0) {
    // for ($i = 0; $i < sizeof($vm_id); $i++) {
    foreach ($vm_id_data as $vm_nid) {
      if ($vm_nid) {
        $vm_get_data = node_load($vm_nid);
        $check_flash_accel_installed = $vm_get_data->field_driver_status['und'][0]['value'];
        if ($check_flash_accel_installed == "Agent Installed") {
          $vm_data = mercury_management_get_host_dc_vc_of_vm($vm_nid);
          $vcInfo = node_load($vm_data['vcenter']);
          $vc_hostname = $vcInfo->field_hostname['und'][0]['value'];
          $vc_username = fmc_cipher::decrypt($vcInfo->field_username['und'][0]['value']);
          $vc_password = fmc_cipher::decrypt($vcInfo->field_password['und'][0]['value']);
          $host_nid = $vm_data['host'];
          $host_data = node_load($host_nid);

          $host_username = mercury_management_get_host_username($host_data);
          $host_password = mercury_management_get_host_password($host_data);

          $num_segments = (ceil($num_segment / 256));

          // Get available cache across all hosts
          $available_segments = mercury_management_availableCache($vm_nid);

          //Get the minimun Cache Space setting value for a VM (in GB)
          // XXX - currently assumes 256MB segments .. In the future we should get this from host
          $cache_space_settings_value = variable_get('minimum_cache_space_vm', 1024);
          $allocated_vm_cache_space_settings = ($cache_space_settings_value * 1024) / 256;

          //Check if the Host is in Maintenance mode (Do not Assign Device)
          $get_host_info = exec("/usr/lib/vmware-vcli/apps/host/host_control.py '" . trim($host_data->title) . "' '" . $host_username . "' '" . $host_password . "' 1 | grep 'CacheState'");
          $cache_state = explode(':', $get_host_info);
          if ($cache_state[1] != 3) {
            mercury_utilities_fmc_log_message('Cache Mgmt', t('Flash device on host @host_name is not initialized. Please initialize the device prior to allocating cache space to the VMs.', array('@host_name' => $host_data->title)), WATCHDOG_WARNING);
          } else if ($num_segments == 1 && !is_numeric($num_segments)) {
            mercury_utilities_fmc_log_message(t('Invalid cache size specified on host @host_name. Please enter a valid value.', array('@host_name' => $host->title)), WATCHDOG_ERROR);
          } else {
            if ($num_segments < $allocated_vm_cache_space_settings) {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache size specified is smaller than minimal cache size value of @num_segment GB.', array('@num_segment' => $cache_space_settings_value, '@vm' => $vm_get_data->title)), WATCHDOG_ERROR, 'show');
            } else if ($num_segments <= $available_segments) {
              // XX - revisit to ensure this is ok when bulk allocation support is added
              $available_datastores = mercury_management_vm_get_valid_allocation_datastores($vm_get_data);
              $vmfs_datastore_name = mercury_management_vm_recommend_allocation_datastore($available_datastores);
              $allocated_status = mercury_management_allocateCacheToVM($vc_hostname, $host_nid, $vm_nid, $vmfs_datastore_name, $num_segments, $vc_username, $vc_password);

              if ($allocated_status == "attached") {
                mercury_utilities_host_refresh_action($host_nid, "no_refresh");
                mercury_utilities_vm_refresh_action($vm_nid, "no_refresh");
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache space was successfully allocated to the VM "@vm_title".', array('@vm_title' => $vm_get_data->title)));
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache format operation is in progress on VM "@vm_title". Please wait for format to complete before attempting other cache changes on this VM.', array('@vm_title' => $vm_get_data->title)), WATCHDOG_WARNING);
              } else if ($allocated_status == "error") {
                mercury_utilities_fmc_log_message('Cache Mgmt', t('Failed to allocate cache space to the VM @vm. Please check log for details', array('@vm' => $vm_get_data->title)), WATCHDOG_ERROR);
              } else {
                mercury_utilities_fmc_log_message($allocated_status, WATCHDOG_WARNING);
              }
            } else {
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache size specified is larger than available size of @avail_segment GB.', array('@avail_segment' => ($available_segments * 256) / 1024)), WATCHDOG_ERROR, 'show');
            }
          }
        } elseif ($check_flash_accel_installed == "Agent Not Installed") {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Flash Accel agent is not yet installed. Please install the package to allocate space to the VM @vm.', array('@vm' => $vm_get_data->title)), WATCHDOG_ERROR, 'show');
        } elseif ($check_flash_accel_installed == "Unable to Communicate with VM") {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Unable to communicate with VM @vm as it may be powered off or VMware tools is not running.', array('@vm' => $vm_get_data->title)), WATCHDOG_ERROR);
        }
      }
    }
  }
}

