<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for vMotion migration.
 */

/**
 * Function to provide Migration Settings interface
 */
function mercury_utilities_migration_settings_form() {
  $form = array();
  $form['migration_description_title'] = array(
    '#type' => 'markup',
    '#markup' => t('<h2>Migration Policy Settings</h2>'),
  );


  $form['fmc_log_settings']['log_description'] = array(
    '#type' => 'markup',
    // TODO: Improper use of <b> tag.
    // Cannot contain <ul>, would be better to do with CSS.
    '#markup' => t('<b>
  Select the default migration policy to use when allocating cache to Flash Accel
  enabled VMs. First specify whether migration should be enabled for cached VMs,
  then select the scope of the migration:
<br/>
<ul>
<li>Cluster, for migrating to hosts in the same cluster.</li>
<li>Datacenter, for migrating to hosts in the same datacenter.</li>
<li>Host, for migrating to the custom set of hosts.</li>
</ul>
<br/>
The hosts that are automatically selected based on the migration policy can be changed
by specifying a custom set of hosts using the Advanced->Migration option in the
wrench drop-down menu for the VM.
<br/>
NOTE: Migration targets are determined at the time of cache allocation. Changing the
policy after cache allocation has no effect on migration targets.</b>'));

  $form['enable_migration'] = array(
    '#type' => 'checkbox',
    '#title' => 'Enable VM Migration',
    '#default_value' => variable_get('enable_migration', 1),
  );
  $form['fmc_migration_settings'] = array(
    '#type' => 'fieldset',
    '#title' => 'Migration Policy Settings',
    '#collapsible' => false,
    '#collapsed' => false
  );

  $policies = array(2 => 'Cluster', 3 => 'Data Center', 4 => 'Host');

  $form['fmc_migration_settings']['migration_policy'] = array(
    '#type' => 'radios',
    '#title' => t('Select a Migration Policy'),
    '#default_value' => variable_get('migration_policy', 2),
    '#description' => t('Select the default migration policy.'),
    '#options' => $policies,
    '#attributes' => array('disabled' => 'disabled'),
    '#suffix' => '<script>
             	jQuery("#mercury-utilities-migration-settings-form #edit-submit").live("click", function() {
  							jQuery("#mercury-utilities-migration-settings-form #edit-submit").attr("disabled", "disabled");
             	});
  					</script>'
  );

  return system_settings_form($form);
}
