<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for general vdisk actions.
 */

/**
 * Function to get all the VM Disks Metric Nids under a VM Disks
 * @param $vdisk_id
 * @return vDisk Metric value
 */
function mercury_utilities_vm_vdisk_metric_nid_fetch($vdisk_id) {
  $vdisk_metric_nid = '';
  $vdisk_metric_query = db_select('node', 'node');
  $vdisk_metric_query->leftJoin('field_data_field_vdisk', 'field_data_field_vdisk', 'node.nid = field_data_field_vdisk.entity_id AND field_data_field_vdisk.entity_type = :node AND field_data_field_vdisk.deleted = :deleted', array(':node' => 'node', ':deleted' => 0));
  $vdisk_metric_query->fields('node', array('nid'));
  $vdisk_metric_query->condition('node.status', 1)
    ->condition('field_data_field_vdisk.field_vdisk_target_id', $vdisk_id)
    ->condition('node.type', 'vdisk_metrics');
  $vdisk_metric_result = $vdisk_metric_query->orderBy('node.created', 'ASC')
    ->execute();
  while ($vdisk_metric_row = $vdisk_metric_result->fetch()) {
    $vdisk_metric_nid = $vdisk_metric_row->nid;
  }
  return $vdisk_metric_nid;
}

/**
 * Function to VM Disks Status Icon
 * @param $vm_id, $vdisk_id
 * @return status color
 * @deprecated This should be replaced with something more like mercury_management_get_vm_status().
 */
function mercury_utilities_vm_vdisk_status_icon_value($vm_id, $vdisk_id) {
  // If the VM is not in a good state, the disk is also not in a good state.
  $vm_node = node_load($vm_id);
  $vm_status_details = mercury_management_get_vm_status($vm_node);
  if ($vm_status_details['status_color'] != 'green') {
    return $vm_status_details['status_color'];
  }

  $vdisk_node = node_load($vdisk_id);
  $vdisk_op_state = field_get_items('node', $vdisk_node, 'field_fa_operational_state');
  if (!empty($vdisk_op_state[0]['value']) && $vdisk_op_state[0]['value'] == "OP_NORMAL") {
    $vdisk_status = "green";
  } else {
    $vdisk_status = "yellow";
  }

  return $vdisk_status;
}
