<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * This file contains functions for vdisk wrench actions.
 */

function mercury_utilities_vdisk_wrench_menu($vdisk_id, $vdisk_node = NULL) {
  $str = '';
  if (!isset($vdisk_node)) {
    $vdisk_node = node_load($vdisk_id);
  }
  if (isset($vdisk_node->title)) {
    $vdisk_name = $vdisk_node->title;
    $vdisk_name = str_replace(" ", "__", $vdisk_name);
  }
  $str .= '<div class = "wrench-menu-vdisk wrench-menu ' . $vdisk_name . '"  id = "wrench-menu-vdisk-' . $vdisk_id . '">';
  $str .= '<ul class = "first-level-ul">';
  $str .= '<li class = "first-level-li expandable">Cache State';
  $str .= '<ul class = "second-level-ul">';
  $str .= '<li class = "second-level-li vdisk-cache-enable-link">' . l('Enable', 'vdisk/settings/HgSetDeviceState/CacheState/enable/' . $vdisk_id) . '</li>';
  $str .= '<li class = "second-level-li last vdisk-cache-disable-link">' . l('Disable', 'vdisk/settings/HgSetDeviceState/CacheState/disable/' . $vdisk_id) . '</li>';
  $str .= '</ul>';
  $str .= '</li>';
  $str .= '<li class = "first-level-li expandable">Cache Mode';
  $str .= '<ul class = "second-level-ul">';
  $str .= '<li class = "second-level-li vdisk-writethru-link">' . l('Write Thru', 'vdisk/settings/HgSetDeviceState/CacheMode/writethru/' . $vdisk_id) . '</li>';
  $str .= '<li class = "second-level-li vdisk-writearound-link">' . l('Write Around', 'vdisk/settings/HgSetDeviceState/CacheMode/writearound/' . $vdisk_id) . '</li>';
  $str .= '<li class = "second-level-li last vdisk-passthru-link">' . l('Pass Thru', 'vdisk/settings/HgSetDeviceState/CacheMode/passthru/' . $vdisk_id) . '</li>';
  $str .= '</ul>';
  $str .= '</li>';
  $str .= '<li class = "first-level-li expandable">Cache Metrics';
  $str .= '<ul class = "second-level-ul">';
  $str .= '<li class = "second-level-li vdisk-metric-enable-link">' . l('Enable', 'vdisk/settings/HgSetDeviceState/PerfState/enable/' . $vdisk_id) . '</li>';
  $str .= '<li class = "second-level-li last vdisk-metric-disable-link">' . l('Disable', 'vdisk/settings/HgSetDeviceState/PerfState/disable/' . $vdisk_id) . '</li>';
  $str .= '</ul>';
  $str .= '</li>';
  $str .= '<li class = "first-level-li">' . ctools_popups_vdisk_settings_link('Advanced', $vdisk_id, 'settings', 'advance') . '</li>';
  $str .= '<li class = "first-level-li last">' . l(t('Refresh'), 'refresh/vdisk/' . $vdisk_id) . '</li>';
  $str .= '</ul>';
  $str .= '</div>';
  return $str;
}

function mercury_utilities_vdisk_settings_popup($type, $action, $vdisk_id) {
  $output = '';
  $vdisk_node = node_load($vdisk_id);
  $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
  $vm_node = node_load($vdisk_vm[0]['target_id']);
  $vm_name = $vm_node->title;
  $driver_status = field_get_items('node', $vm_node, 'field_driver_status');
  $cachespace_status = field_get_items('node', $vm_node, 'field_cachespace');
  $output .= '<div class = "vm-disk-advance-form">';
  $output .= '<div class = "advance-tabs-wrapper clearfix"><div class = "advance-tab active" id = "set-cache-tab">Set Cache State</div></div>';
  $output .= '<div class = "tab-menu" id = "set-cache">';
  $output .= '<div class = "set-cache-form">';
  if ($driver_status[0]['value'] == 'Agent Installed') {
    if ($cachespace_status[0]['value'] != '') {
      $output .= drupal_render(drupal_get_form('mercury_utilities_vm_disk_settings_advance_options_form', $vdisk_id));
    } else {
      $output .= 'No cache device allocated on VM: ' . $vm_node->title . '.';
    }
  } else {
    $output .= 'Flash Accel Agent not Installed or the VM: ' . $vm_node->title . 'is Unavailable.';
  }
  $output .= '</div>';
  $output .= '</div>';
  $output .= '</div>';
  return $output;
}

function mercury_utilities_vm_disk_settings_advance_options_form($form, &$form_state, $vdisk_id) {
  $vdisk_node = node_load($vdisk_id);
  $perf_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');
  $cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
  $cache_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
  if ($cache_state[0]['value'] == "ADMIN_ENABLED") {
    $cache_state_default = 0;
  } else {
    $cache_state_default = 1;
  }
  if ($cache_mode[0]['value'] == "CM_WRITETHRU") {
    $cache_mode_default = 0;
  } elseif ($cache_mode[0]['value'] == "CM_PASSTHRU") {
    $cache_mode_default = 1;
  } else {
    $cache_mode_default = 2;
  }
  if ($perf_state[0]['value'] == "ADMIN_ENABLED") {
    $perf_state_default = 0;
  } else {
    $perf_state_default = 1;
  }
  $cache_states = array(0 => t('Enable'), 1 => t('Disable'));
  $cache_modes = array(0 => t('Write Thru'), 1 => t('Pass Thru'), 2 => t('Write Around'));
  $perf_states = array(0 => t('Enable'), 1 => t('Disable'));
  $form['cachestate'] = array(
    '#type' => 'radios',
    '#title' => t('Cache State'),
    '#default_value' => $cache_state_default,
    '#options' => $cache_states,
    '#description' => t('Select the cache state.'),
    /* '#access' => $admin, */
  );
  $form['cachemode'] = array(
    '#type' => 'radios',
    '#title' => t('Cache Mode'),
    '#default_value' => $cache_mode_default,
    '#options' => $cache_modes,
    '#description' => t('Select the cache mode.'),
    /* '#access' => $admin, */
  );
  $form['perfstate'] = array(
    '#type' => 'radios',
    '#title' => t('Metrics'),
    '#default_value' => $perf_state_default,
    '#options' => $perf_states,
    '#description' => t('Select the cache metric state.'),
    /* '#access' => $admin, */
  );
  $form['vdisk_id'] = array(
    '#type' => 'hidden',
    '#value' => $vdisk_id
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
    '#suffix' => '<script>jQuery("#edit-submit").click(function () { jQuery("#edit-submit").hide()});</script>'
  );
  return $form;
}

function mercury_utilities_vm_disk_settings_advance_options_form_submit($form, &$form_state) {
  global $base_url;
  ctools_include('ajax');
  ctools_include('modal');
  $values = $form_state['values'];
  if ($values['vdisk_id'] != '') {
    $vdisk_id = $values['vdisk_id'];
    $vdisk_node = node_load($vdisk_id);
    $node_perf_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');
    $node_cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
    $node_cache_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
    $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
    $vdisk_identifier_value = $vdisk_identifier[0]['value'];
    $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
    $vdisk_vm_id = $vdisk_vm[0]['target_id'];
    $vm_node = node_load($vdisk_vm_id);
    $selected_cache_state = $values['cachestate'];
    $selected_cache_mode = $values['cachemode'];
    $selected_perf_state = $values['perfstate'];
    $no_action = 0;
    if ($selected_cache_state == 0) {
      $cache_state = "ADMIN_ENABLED";
    } elseif ($selected_cache_state == 1) {
      $cache_state = "ADMIN_DISABLED";
    }
    if ($selected_cache_mode == 0) {
      $cache_mode = "CM_WRITETHRU";
    } elseif ($selected_cache_mode == 1) {
      $cache_mode = "CM_PASSTHRU";
    } elseif ($selected_cache_mode == 2) {
      $cache_mode = "CM_WRITEAROUND";
    }
    if ($selected_perf_state == 0) {
      $perf_state = "ADMIN_ENABLED";
    } elseif ($selected_perf_state == 1) {
      $perf_state = "ADMIN_DISABLED";
    }
    if ($node_cache_state[0]['value'] != $cache_state) {
      $cache_state_flag = 1;
    } else {
      $cache_state_flag = 0;
    }
    if ($node_cache_mode[0]['value'] != $cache_mode) {
      $cache_mode_flag = 1;
    } else {
      $cache_mode_flag = 0;
    }
    if ($node_perf_state[0]['value'] != $perf_state) {
      $perf_state_flag = 1;
    } else {
      $perf_state_flag = 0;
    }
    // XXX: Accidental assignment.  Fix this in Copper.
    // Fortunately it accidentally works OK, in that the assignment
    // is not an important var and it just results in sending too many params.
    if ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
      $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'CacheMode' => $cache_mode, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 1 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
      $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'CacheMode' => $cache_mode, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
      $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 1 && $cache_mode_flag == 0 && $perf_state_flag == 0) {
      $params->DeviceStateRequest['0'] = array('CacheState' => $cache_state, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 1) {
      $params->DeviceStateRequest['0'] = array('CacheMode' => $cache_mode, 'PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 0 && $cache_mode_flag == 1 && $perf_state_flag == 0) {
      $params->DeviceStateRequest['0'] = array('CacheMode' => $cache_mode, 'NaaId' => $vdisk_identifier_value);
    } elseif ($cache_state_flag = 0 && $cache_mode_flag == 0 && $perf_state_flag == 1) {
      $params->DeviceStateRequest['0'] = array('PerfState' => $perf_state, 'NaaId' => $vdisk_identifier_value);
    } else {
      $no_action = 1;
    }
    if ($no_action == 0) {
      # Send the web service request
      $disk_param = array('request' => $params);
      $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgSetDeviceState', $disk_param);
      if ($vdisk_result == 'error_wsdl_call') {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM @vm. Please refresh VM and try again.', array('@vm' => $vm_node->title)), WATCHDOG_WARNING);
        if ($cache_state == "ADMIN_ENABLED") {
          mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
          mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
        }
      } elseif ($vdisk_result['response_status'] == 'success') {
        # Space for success message for action success.
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache advanced operation successful.'), WATCHDOG_NOTICE, 'show');
        # Send request to read the cache information back and update
        $param = array();
        $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
        if ($attrInfo != 'error_wsdl_call') {
          $diskCount = $attrInfo['disk_count'];
          for ($index = 0; $index < $diskCount; $index++) {
            # compare against current disk
            $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
            if ($identifier == $vdisk_identifier_value) {
              $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
              $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
              $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
              $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
              $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
              node_save($vdisk_node);
              mercury_utilities_fmc_log_message('Cache Mgmt', t('Node @node_title update successful.', array('@node_title' => $vdisk_node->title)), WATCHDOG_NOTICE, 'show');
            }
          }
        } else {
          mercury_utilities_fmc_log_message('Cache Mgmt', t('Node @node_title update failed.', array('@node_title' => $vdisk_node->title)), WATCHDOG_WARNING, 'show');
        }
      } else {
        mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM. Please refresh VM and try again.'), WATCHDOG_ERROR);
        if ($cache_state == "ADMIN_ENABLED") {
          mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
          mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
        }
      }
    } else {
      mercury_utilities_fmc_log_message('Cache Mgmt', t('No VM cache changes were performed.'), WATCHDOG_WARNING);
    }
  }
  $out = array();
  $out[] = ctools_ajax_command_redirect($_SERVER['HTTP_REFERER']);
  print ajax_render($out);
  exit;
}

function mercury_utilities_vdiskinfo_popup($vdisk_id) {
  $output = '';
  $vdisk_node = node_load($vdisk_id);
  $vdisk_name = $vdisk_node->title;

  /* fetching disk cache values from the database */
  $vdsik_capacity = field_get_items('node', $vdisk_node, 'field_capacity');
  $vdisk_freespace = field_get_items('node', $vdisk_node, 'field_freespace');
  $vdisk_path = field_get_items('node', $vdisk_node, 'field_path');
  $cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
  $admin_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
  $op_state = field_get_items('node', $vdisk_node, 'field_fa_operational_state');
  $op_message = field_get_items('node', $vdisk_node, 'field_fa_operational_message');
  $perf_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');
  $identifier = field_get_items('node', $vdisk_node, 'field_vdisk_id');
  $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
  $vm_name = node_load($vdisk_vm[0]['target_id'])->title;

  /* changing the disk cache values to human readable form */
  $admin_state_display = get_human_readable_name($admin_state[0]['value']);
  $cache_mode_display = get_human_readable_name($cache_mode[0]['value']);
  $op_state_display = get_human_readable_name($op_state[0]['value']);
  $perf_state_display = get_human_readable_name($perf_state[0]['value']);

  /* fetching disk metric values from database */
  $metric_id = mercury_utilities_vm_vdisk_metric_nid_fetch($vdisk_id);
  if ($metric_id != '') {
    $disk_metric_node = node_load($metric_id);
    $disk_read_latency = field_get_items('node', $disk_metric_node, 'field_vdisk_read_latency');
    $disk_write_latency = field_get_items('node', $disk_metric_node, 'field_vdisk_write_latency');
    $disk_read_ops = field_get_items('node', $disk_metric_node, 'field_vdisk_read_ops');
    $disk_write_ops = field_get_items('node', $disk_metric_node, 'field_vdisk_write_ops');
    $disk_hits = field_get_items('node', $disk_metric_node, 'field_vdisk_hit_rate_pc');
    $disk_cache_latency = field_get_items('node', $disk_metric_node, 'field_vdisk_cache_latency');
    $disk_population_perc = field_get_items('node', $disk_metric_node, 'field_vdisk_population_pc');
    $disk_insertion_perc = field_get_items('node', $disk_metric_node, 'field_vdisk_insertion_rate_pc');
  }

  $output .= '<span class = "vdisk-name">' . $vdisk_name . '</span>';
  $output .= '<div class="node-inner-section first">';
  $output .= '<div class="node-inner-header">' . t('vDisk Overview') . '</div>';
  $output .= '<div class="node-inner-container">';
  $output .= '<div class="node-inner-left">';
  // Next line commented out for barium solution to burt 695468
  //  $output .= '<div class="info-odd"><div class = "vdisk-capacity">Capacity: ' . number_format($vdsik_capacity[0]['value']/1073741824, 2,'.','') . 'GB</div></div>';
  // Next line commented out at some previous time; not part of barium solution to burt 695468
  //  $output .= '<div class = "vdisk-freespace">Free Space: ' . ceil($vdisk_freespace[0]['value']/1073741824) . 'GB</div></div>';
  $output .= '<div class="info-even"><div class = "vdisk-id">vDisk Identifier: ' . ($identifier[0]['value']) . '</div></div>';
  $output .= '</div>';
  $output .= '<div class="node-inner-right">';
  $output .= '<div class="info-odd"><div class = "vdisk-path">Path: ' . $vdisk_path[0]['value'] . '</div></div>';
  $output .= '</div>';
  $output .= '<div class="clr"></div>';
  $output .= '</div>';
  $output .= '<div class="node-inner-header">' . t('Flash Accel Overview') . '</div>';
  $output .= '<div class="node-inner-container">';
  $output .= '<div class="node-inner-left">';
  $output .= '<div class="info-odd"><div class = "vdisk-admin-state">Cache State: ' . $admin_state_display . '</div></div>';
  $output .= '<div class="info-even"><div class = "vdisk-cache-mode">Cache Mode: ' . $cache_mode_display . '</div></div>';
  $output .= '<div class="info-odd"><div class = "vdisk-perf-state">Cache Metrics: ' . $perf_state_display . '</div></div>';
  $output .= '</div>';
  $output .= '<div class="node-inner-right">';
  $output .= '<div class="info-odd"><div class = "vdisk-op-state">Operational State: ' . $op_state_display . '</div></div>';
  $output .= '<div class="info-even"><div class = "vdisk-op-message">Operational Message: ' . $op_message[0]['value'] . '</div></div>';
  $output .= '</div>';
  $output .= '<div class="clr"></div>';
  $output .= '</div>';
  $output .= '<div class="node-inner-header">' . t('Metric Overview') . '</div>';
  $output .= '<div class="node-inner-container">';
  if ($perf_state[0]['value'] == "ADMIN_ENABLED" && $metric_id != '') {
    $output .= '<div class="node-inner-left">';
    $output .= '<div class="info-odd"><div class = "vdisk-read-latency">Read Latency (ms): ' . $disk_read_latency[0]['value'] . '</div></div>';
    $output .= '<div class="info-even"><div class = "vdisk-write-latency">Write Latency (ms): ' . $disk_write_latency[0]['value'] . '</div></div>';
    $output .= '<div class="info-odd"><div class = "vdisk-hit-rate">Hit Rate %: ' . $disk_hits[0]['value'] . '</div></div>';
    $output .= '<div class="info-even"><div class = "vdisk-population">Population %: ' . $disk_population_perc[0]['value'] . '</div></div>';
    $output .= '</div>';
    $output .= '<div class="node-inner-right">';
    $output .= '<div class="info-odd"><div class = "vdisk-read-ops">Read Ops: ' . $disk_read_ops[0]['value'] . '</div></div>';
    $output .= '<div class="info-even"><div class = "vdisk-write-ops">Write Ops: ' . $disk_write_ops[0]['value'] . '</div></div>';
    $output .= '<div class="info-odd"><div class = "vdisk-cache-latency">Cache Latency (ms): ' . $disk_cache_latency[0]['value'] . '</div></div>';
    $output .= '<div class="info-even"><div class = "vdisk-insertion-rate">Insertion rate %: ' . $disk_insertion_perc[0]['value'] . '</div></div>';
    $output .= '</div>';
    $output .= '<div class="clr"></div>';
  } else {
    $output .= '<div class = "disk-metric-error"><strong>N/A</strong></div>';
  }
  $output .= '</div>';
  $output .= '</div>';
  return $output;
}

function mercury_utilities_vdisk_settings_action($method, $type, $action, $vdisk_id) {
  global $base_url;
  $params = new stdClass();
  $vdisk_node = node_load($vdisk_id);

  $vdisk_identifier = field_get_items('node', $vdisk_node, 'field_vdisk_identifier');
  $vdisk_identifier_value = $vdisk_identifier[0]['value'];

  $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
  $vdisk_vm_id = $vdisk_vm[0]['target_id'];
  $vm_info = node_load($vdisk_vm_id);

  $disk_num = field_get_items('node', $vdisk_node, 'field_disk_index');
  $disk_num_value = $disk_num[0]['value'];

  $disk_path = field_get_items('node', $vdisk_node, 'field_path');

  $vdisk_id = field_get_items('node', $vdisk_node, 'field_vdisk_id');
  $vdisk_id_value = $vdisk_id[0]['value'];

  $cache_mode = field_get_items('node', $vdisk_node, 'field_fa_cache_mode');
  $admin_state = field_get_items('node', $vdisk_node, 'field_fa_administration_state');
  $perf_state = field_get_items('node', $vdisk_node, 'field_fa_performance_state');

  # if identifier is empty we cannot change state
  if ($vdisk_id_value == '' || $vdisk_id_value == "Not Known") {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('Missing or invalid vDisk. Cache reconfiguration failed on VM @vm. Please refresh VM and try again.', array('@vm' => $vm_info->title)), WATCHDOG_ERROR);
    goto vdisk_setting_done;
  }

  # we have nothing to do if this is not changing state
  if ($method != "HgSetDeviceState") {
    goto vdisk_setting_done;
  }

  switch ($type) {
    case "CacheState":
      $operation = "Cache state";
      break;
    case "PerfState":
      $operation = "Cache metrics";
      break;
    case "CacheMode":
      $operation = "Cache mode";
      break;
  }

  # Configure the parameter arg to the current mode based on
  # the current state and the mode that is requested
  if ($type == "CacheMode") {
    $target_mode = "";
    $current_mode = $cache_mode[0]['value'];
    switch ($action) {
      case "passthru":
        if ($current_mode != "CM_PASSTHRU") {
          $target_mode = "CM_PASSTHRU";
        }
        break;
      case "writethru":
        if ($current_mode != "CM_WRITETHRU") {
          $target_mode = "CM_WRITETHRU";
        }
        break;
      case "writearound":
        if ($current_mode != "CM_WRITEAROUND") {
          $target_mode = "CM_WRITEAROUND";
        }
    }
    if ($target_mode == "") {
      mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache mode is already set to @mode for vDisk @vdisk. If incorrect, please refresh VM and try again.', array('@mode' => $action, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
      goto vdisk_setting_done;
    } else {
      $params->DeviceStateRequest['0'] = array('CacheMode' => $target_mode, 'NaaId' => $vdisk_identifier_value);
    }
  }

  # Configure the parameter arg to the current mode based on
  # the current state and the mode that is requested
  if ($type == "CacheState" || $type == "PerfState") {
    $target_state = "";
    $current_state = ($type == "CacheState") ? $admin_state[0]['value'] : $perf_state[0]['value'];
    switch ($action) {
      case "enable":
        if ($current_state != "ADMIN_ENABLED") {
          $target_state = "ADMIN_ENABLED";
        }
        break;
      case "disable":
        if ($current_state != "ADMIN_DISABLED") {
          $target_state = "ADMIN_DISABLED";
        }
        break;
    }

    if ($target_state == "") {
      $state = $action . 'd';
      mercury_utilities_fmc_log_message('Cache Mgmt', t("@type is already @state for vDisk @vdisk. If incorrect, please refresh VM and try again.", array('@type' => $operation, '@state' => $state, '@vdisk' => $vdisk_node->title)), WATCHDOG_WARNING);
      goto vdisk_setting_done;
    } else {
      $params->DeviceStateRequest['0'] = array($type => $target_state, 'NaaId' => $vdisk_identifier_value);
    }
  }

  # Send the web service request
  $disk_param = array('request' => $params);
  $vdisk_result = mercury_management_cache_operation('nid', $vdisk_vm_id, $method, $disk_param);
  if ($vdisk_result == 'error_wsdl_call') {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM @vm. Please refresh VM and try again.', array('@vm' => $vm_info->title)), WATCHDOG_WARNING);
    if ($target_state == "ADMIN_ENABLED") {
      mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
      mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
    }
    goto vdisk_setting_done;
  } elseif ($vdisk_result['response_status'] == 'success') {
    $state = ($type == "CacheMode") ? $action : $action . 'd';
    mercury_utilities_fmc_log_message('Cache Mgmt', t("@operation @action for vDisk @vdisk.", array('@operation' => $operation, '@action' => $state, '@vdisk' => $vdisk_node->title)));
  } else {
    mercury_utilities_fmc_log_message('Cache Mgmt', t('Cache reconfiguration failed on VM. Please refresh VM and try again.'), WATCHDOG_ERROR);
    if ($target_state == "ADMIN_ENABLED") {
      mercury_utilities_fmc_log_message('Cache Mgmt', t("If the cache operation continues to fail, please check the Installation and Administration guide to confirm that all memory and other requirements have been met."), WATCHDOG_ERROR);
      mercury_utilities_fmc_log_message('Cache Mgmt', t("You can also try rebooting the VM, formatting the cache in the VM's advanced settings, and then enabling the cache again."), WATCHDOG_ERROR);
    }
  }

  # Send request to read the cache information back and update
  $param = array();
  $attrInfo = mercury_management_cache_operation('nid', $vdisk_vm_id, 'HgGetCacheInfo', $param);
  if ($attrInfo != 'error_wsdl_call') {
    $diskCount = $attrInfo['disk_count'];
    for ($index = 0; $index < $diskCount; $index++) {
      # compare against current disk
      $identifier = strtolower(trim($attrInfo[$index]['vdisk_identifier']));
      if ($identifier == $vdisk_identifier_value) {
        $vdisk_node->field_fa_cache_mode['und'][0]['value'] = $attrInfo[$index]['cache_mode'];
        $vdisk_node->field_fa_administration_state['und'][0]['value'] = $attrInfo[$index]['admin_state'];
        $vdisk_node->field_fa_performance_state['und'][0]['value'] = $attrInfo[$index]['perf_state'];
        $vdisk_node->field_fa_operational_state['und'][0]['value'] = $attrInfo[$index]['op_state'];
        $vdisk_node->field_fa_operational_message['und'][0]['value'] = $attrInfo[$index]['op_message'];
        node_save($vdisk_node);
      }
    }
  }

  vdisk_setting_done:
  //drupal_goto($base_url);
  drupal_goto($_SERVER['HTTP_REFERER']);
}

/**
 * Function to refresh vDisk for VM Disk page wrench menu refresh
 */
function mercury_utilities_vdisk_refresh_action($vdisk_id) {
  $vdisk_node = node_load($vdisk_id);
  $vdisk_vm = field_get_items('node', $vdisk_node, 'field_virtual_machine');
  mercury_utilities_vm_refresh_action($vdisk_vm[0]['target_id']);
}

