<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

class MercuryTestingUtilities {

  // TODO: Does it make sense to just make these methods public?
  // Or maybe is this a symptom of the class organization needing a rework?
  // We aren't modeling a domain in the normal sense, so maybe this is OK.
  public static function callProtectedMethod($className, $methodName) {
    $class = new ReflectionClass($className);
    $method = $class->getMethod($methodName);
    $method->setAccessible(true);
    $target = new MercuryImportExport();

    // This method takes optional arguments.
    $args = func_get_args();
    if (isset($args[2])) {
      // Remove $className and $methodName.
      // Remainder gets passed to the function.
      array_shift($args);
      array_shift($args);
      return $method->invokeArgs($target, $args);
    }

    // Called without additional arguments.
    return $method->invoke($target);
  }
}
