<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 * TODO: Check discovery state and indicate fields that may not be accurate.
 * We could either do this by organizing the display into groups by source
 * or by doing the indications on a per-field level.
 * For now leaving the indication off is OK because the discovery state text
 * gives a good indication for what information could be discovered, and the
 * multi-state discovery system tends to only keep information that is likely
 * to be still true (install version, cache allocated, and so on).
 *
 * Note that phase 20 + uninstalled = know cache state definitively (is none),
 * but 20 + installed = error.
 */

  //$admin_state = array_pop(array_pop(field_get_items('node', $node, 'field_fa_administration_state')));
  $status_details = mercury_management_get_vm_status($node);
	$perf_state = array_pop(array_pop(field_get_items('node', $node, 'field_fa_performance_state')));
	$metrics_reset_interval = (!empty($node->field_fa_metrics_reset_interval)) ? $node->field_fa_metrics_reset_interval['und'][0]['value']: '';
	$metrics_warning = ($perf_state == "ADMIN_ENABLED" && $metrics_reset_interval == 0) ? " (<font color='red'>WARNING: Reset interval is set to 0 on VM</font>)" : "";
	$refresh_image = '<img src = " ' . base_path() . drupal_get_path('theme', 'mercury') . '/images/refresh.png" class = "refresh-spinner" alt="Refresh" />';
	$vcInfo = mercury_management_vcenter_details();
	$vc_hostname = $vcInfo->field_hostname['und'][0]['value'];
	$vc_username = fmc_cipher::decrypt($vcInfo->field_username['und'][0]['value']);
	$vc_password = fmc_cipher::decrypt($vcInfo->field_password['und'][0]['value']);

  // TODO: Revisit this.  Either this page should show the *cached* host ref
  // or we should actually update the host field if this turns up something new.
  $dataArr = array();
  $currHost = '';
  $currently_running_host = '';
	exec("perl /usr/lib/vmware-vcli/apps/general/vcenterdiscover.pl --url https://" . $vc_hostname . "/sdk/vimService  --username '" . $vc_username . "' --password '" . $vc_password . "' --operation vmlist", $dataArr);
	if (!empty($dataArr)) {
	  foreach ($dataArr as $item) {
	    $host_split = explode('Host :', $item);
	    if (count($host_split) > 1) {
	      $currHost= trim($host_split[1]);
	
	    }
	    $vm_split = explode('VM :', $item);
	    if (count($vm_split) > 1) {
	      if (trim($vm_split[1]) == $node->title) {
	        $currently_running_host=  $currHost;
	      }
	    }
	  }
	}
        $driver_status = $node->field_driver_status['und'][0]['value'];
        $flash_accel_state = 'Not Known';
        if ($driver_status == 'Agent Installed'){
          $flash_accel_state = 'Installed';
        } elseif ($driver_status == 'Agent Not Installed') {
          $flash_accel_state = 'Not Installed';
        } elseif ($driver_status == 'Not Compatible') {
          $flash_accel_state = 'Not Compatible';
        }

  // Get the the IP address and hostname - if either of it matches the address we have in the vm_address
  // field display an asterix next to the name. Also if the vm_address field has an unique IP address
  // display that IP address instead of the default VM IP address and display an asterix next to it.
  $ip_address = '';
  if (!empty($node->field_vm_address_custom['und'][0]['value'])) {
    $ip_address = $node->field_vm_address_custom['und'][0]['value'];
  } elseif (!empty($node->field_vm_ip_address['und'][0]['value'])) {
    $ip_address = $node->field_vm_ip_address['und'][0]['value'];
  }
  $hostname = '';
  if (!empty($node->field_vm_hostname['und'][0]['value'])) {
    $hostname = $node->field_vm_hostname['und'][0]['value'];
  }
  $used_address = mercury_management_get_vm_address($node);
  if (!empty($used_address)) {
    if ($hostname == $used_address) {
      $hostname = $hostname . ' (*)';
    } else {
      $ip_address = $ip_address . ' (*)';
    }
  }

  $warning = mercury_management_vm_agent_compatibility_warning($node);
  if (!empty($warning)) {
    print '<div class="inline-messages warning">' . $warning . '</div>';
  }

	?>
<div class="node-inner-section node-inner-section-first">
	<div class="node-inner-header"><?php print t('Summary');?></div>
	<div class="node-inner-container">
    <div class="info-odd"><label><?php print t('VM State');?>: <span class="vm-status"><?php print $status_details['wrapped_icon']; ?></span> <span><?php print $status_details['status_message']; ?></span></label></div>
    <div class="info-even"><label><?php print t('FAMC Object State');?>: <span><?php print mercury_management_get_discovery_state_text($node); ?></span></label></div>
		<div class="clr"></div>
	</div>
</div>
<div class="node-inner-section">
	<div class="node-inner-header"><?php print t('Attributes');?></div>
	<div class="node-inner-container">
    <div class="node-inner-left">
    <div class="info-odd"><label><?php print t('Host Name');?>: <span><?php print $hostname;?></span></label></div>
			<div class="info-even"><label><?php print t('Memory Size');?>: <span><?php print (!empty($node->field_memory_size)) ? $node->field_memory_size['und'][0]['value'] .' MB': '';?></span></label></div>
                        <div class="info-odd"><label><?php print t('CPU Usage');?>: <span><?php print (!empty($node->field_cpu_usage)) ? $node->field_cpu_usage['und'][0]['value']: '';?></span></label></div>

                </div>
		<div class="node-inner-right">
			<div class="info-odd"><label><?php print t('IP Address');?>: <span><?php print $ip_address?></span></label></div>
			<div class="info-even"><label><?php print t('Host Memory Usage');?>: <span><?php print (!empty($node->field_host_memory_usage)) ? $node->field_host_memory_usage['und'][0]['value']: '';?></span></label></div>
			<div class="info-odd"><label><?php print t('Guest Memory Usage');?>: <span><?php print (!empty($node->field_guest_memory_usage)) ? $node->field_guest_memory_usage['und'][0]['value']: '';?></span></label></div>
		</div>
                <div class="clr"></div>
                <div class="info-even"><label><?php print t('VMware Tools');?>: <span><?php print (!empty($node->field_vmware_tools)) ? $node->field_vmware_tools['und'][0]['value']: '';?></span></label></div>
                <div class="clr"></div>
                <div class="info-odd"><label><?php print t('Guest OS');?>: <span><?php print (!empty($node->field_guest_os)) ? $node->field_guest_os['und'][0]['value']: '';?></span></label></div>
                <div class="clr"></div>
                <div class="info-even"><label><?php print t('VM Path Name');?>: <span><?php print (!empty($node->field_vm_path_name)) ? $node->field_vm_path_name['und'][0]['value']: '';?></span></label></div>
                <hr style="height: 1px; color: #C1CCD8; background-color: #C1CCD8; border: 0;">
                <div class="info-odd"><label><?php print t('Currently Running On Host');?>: <span><?php print ($currently_running_host) ? $currently_running_host : '';?></span></label></div>
		<div class="clr"></div>
	</div>
</div>

<div class="node-inner-section">
	<div class="node-inner-header"><?php print t('Flash Accel Configuration');?></div>
	<div class="node-inner-container">
		<div class="info-even"><label><?php print t('Flash Accel State');?>: <span><?php print $flash_accel_state ; ?></span></label></div>
		<div class="node-inner-left">
			<div class="info-odd"><label><?php print t('VM Agent Version');?>: <span><?php print (!empty($node->field_fa_build_version)) ? $node->field_fa_build_version['und'][0]['value']: '';?></span></label></div>
			<div class="info-even"><label><?php print t('Cache State');?>: <span><?php print (!empty($node->field_fa_administration_state)) ? get_human_readable_name($node->field_fa_administration_state['und'][0]['value']): '';?></span></label></div>
			<div class="info-odd"><label><?php print t('Operational State');?>: <span><?php print (!empty($node->field_fa_operational_state)) ? get_human_readable_name($node->field_fa_operational_state['und'][0]['value']): '';?></span></label></div>
		</div>
		<div class="node-inner-right">
			<div class="info-odd"><label><?php print t('Cache Mode');?>: <span><?php print (!empty($node->field_fa_cache_mode)) ? get_human_readable_name($node->field_fa_cache_mode['und'][0]['value']): '';?></span></label></div>
      <div class="info-even"><label><?php print t('Cache Size');?>: <span><?php print (!empty($node->field_fa_cache_size)) ? number_format($node->field_fa_cache_size['und'][0]['value']*512/1073741824 , 2,'.','') . ' GB': '';?></span></label></div>
			<div class="info-odd"><label><?php print t('Operational Message');?>: <span><?php print (!empty($node->field_fa_operational_message)) ? $node->field_fa_operational_message['und'][0]['value']: '';?></span></label></div>
		</div>
                <div class="clr"></div>
		<div class="info-even"><label><?php print t('Metrics');?>: <span><?php print (!empty($node->field_fa_performance_state)) ? get_human_readable_name($node->field_fa_performance_state['und'][0]['value']) . $metrics_warning : ''; ?></span></label></div>
                <div class="clr"></div>
	</div>
</div>
<?php
// Display metrics if VM cache is enabled and performance monitoring is enabled
//if ($admin_state == 'ADMIN_ENABLED' && $perf_state == 'ADMIN_ENABLED'):
?>
  
<div class="node-inner-section">
	<div class="node-inner-header"><?php print t('Metrics');?></div>
<?php
//if ($perf_state == 'ADMIN_ENABLED' && $metrics_reset_interval > 0):
?>
	<div class="node-inner-container" id="vm-metrics-content">
		<div class="view-content">
			<?php print render($content['vm_metrics_entity_view_1']); ?>
		</div>		
		<div class="clr"></div>
	</div>
<?php
//else:
?>
<!-- 
        <div class="node-inner-container">
	    <div class="node-inner-left">
               <div class="info-odd"><label><?php //print t('N/A'); ?></label></div>
	    </div>
	    <div class="clr"></div>
        </div>
 -->
<?php
//endif;
?>
</div>
<!--
<div class="node-inner-section" style="border: none;">
	<h3 class="table-title"><?php // print t('Virtual Disk Metrics');?></h3>
	<div class="node-inner-container" id="vm-vdisk-metrics-content">
		<div class="view-content">
			<?php //print render($content['vdisk_metric_per_vm_entity_view_1']); ?>
		</div>
		<div class="clr"></div>
	</div>
</div>
-->
<?php
//endif;
?>
