<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 *
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *
 *    jQuery Once - Copyright (c) 2009 Konstantin Käfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

global $user;
if (arg(0) == 'node' && is_numeric(arg(1))) {
  $nodeInfo = node_load(arg(1));
  if ($nodeInfo->type == 'virtual_machine') {
	  $title = 'VM: ' . $title;
  } 
  
  if ($nodeInfo->type == 'host') {
	  $title = 'Host: ' . $title;
  }
}

$brand = strtolower(mercury_utilities_get_fmc_brand_string());
$theme_path = drupal_get_path('theme', 'mercury');

?>
<div id="page" class="<?php print $classes; ?>"<?php print $attributes; ?>>

  <!-- ______________________ HEADER _______________________ -->

  <div id="header">
      <div id="header-top" class="clearfix">
           <div class="header-top-left">
            <?php if ($logo): ?>
              <a href="<?php print $front_page; ?>" title="<?php print t('Home'); ?>" rel="home" id="logo">
                <img src="<?php echo "/$theme_path/images/$brand/header_logo.png"; ?>" alt="<?php print t('Home'); ?>"/>
              </a>
            <?php endif; ?>

            <?php if ($site_name || $site_slogan): ?>
              <div id="name-and-slogan">

                <?php if ($site_name): ?>
                  <?php if ($title): ?>
                    <div id="site-name">
                      <a href="<?php print $front_page; ?>" title="<?php print t('Home'); ?>" rel="home"><?php print $site_name; ?></a>
                    </div>
                  <?php else: /* Use h1 when the content title is empty */ ?>
                    <h1 id="site-name">
                      <a href="<?php print $front_page; ?>" title="<?php print t('Home'); ?>" rel="home"><?php print $site_name; ?></a>
                    </h1>
                  <?php endif; ?>
                <?php endif; ?>

                <?php if ($site_slogan): ?>
                  <div id="site-slogan"><?php print $site_slogan; ?></div>
                <?php endif; ?>

              </div>
            <?php endif; ?>
           </div>

          <div class="header-top-right">

              <?php if ($page['header_top_right']): ?>
                <div id="header-top-right-region">
                  <?php print render($page['header_top_right']); ?>
                </div>
              <?php endif; ?>
           </div>
    </div>
      
    <?php if ($page['header']): ?>
      <div id="header-region">
        <?php print render($page['header']); ?>
      </div>
    <?php endif; ?>

  </div> <!-- /header -->

  <!-- ______________________ MAIN _______________________ -->

  <div id="main" class="clearfix">

    <div id="content">
      <div id="content-inner" class="inner column center">

        <?php if ($breadcrumb || $title|| $messages || $tabs || $action_links): ?>
          <div id="content-header">
						<?php
						$display_title = 1; 
						//Display drupal_set_messages on the following URLs only
			      $ignore_paths = array(			          
			          'user',
			          'admin',
			          'fa_help',
			          'confirm',
			          'view',
			          'rediscover',
			      		'discovery',
			          'config',
			      );
			  
			      $path_start = explode('/', current_path());
			      if (count($path_start) > 0) {
			        $path_get = $path_start[0];
			      } else {
			        $path_get = current_path();
			      }
			  
			      if (in_array($path_get, $ignore_paths)) {
			        print $messages;
			        //print $breadcrumb;			        			        
			      }

			      if ($path_get == 'home' || $path_get == 'vm-inventory' || $path_get == 'host-inventory' || $path_get == 'config') {
			      	$display_title = 0;
			      }
						?>
						
						

            <?php if ($page['highlight']): ?>
              <div id="highlight"><?php print render($page['highlight']) ?></div>
            <?php endif; ?>

            <?php if ($title && $display_title == 1): ?>
              <div class="clearfix title-wrapper">
                    <h1 class="title"><?php print $title; ?></h1>
                    <?php if ($page['title_right']): ?>
                    <div id="title-right" class="title-right">
                        <?php print render($page['title_right']); ?>
                    </div>
                    <?php endif; ?>
              </div>
            <?php endif; ?>

            <?php print render($title_suffix); ?>            
            <?php print render($page['help']); ?>

            <?php if ($tabs): ?>
              <div class="tabs"><?php print render($tabs); ?></div>
            <?php endif; ?>

            <?php if ($action_links): ?>
              <ul class="action-links"><?php print render($action_links); ?></ul>
            <?php endif; ?>
            
          </div> <!-- /#content-header -->
        <?php endif; ?>

        <div id="content-area">
          <?php print render($page['content']) ?>
        </div>

        <?php print $feed_icons; ?>

      </div>
      <?php if ($user->uid > 0): ?>
      <div id="footer">	    
	      <div class="region region-footer">    
					<div class="block block-block block-odd first last clearfix" id="block-block-1">
					  <div class="block-inner">
							<div class="content">
								<div class="fmc-footer-message-box">							  					  
								  <?php 
								    if ($user->uid > 0) {
								    	print $fmc_messages;
								    }
								  ?>							  
								</div>														
							</div>				
					  </div>
					</div> <!-- /block-inner /block -->
				</div>      
    	</div> <!-- /footer -->
    	<?php endif; ?>
    </div> <!-- /content-inner /content -->
    

    <?php if ($main_menu || $secondary_menu): ?>
      <div id="navigation" class="menu <?php if (!empty($main_menu)) {print "with-primary";} if (!empty($secondary_menu)) {print " with-secondary";} ?>">
        <?php print theme('links', array('links' => $main_menu, 'attributes' => array('id' => 'primary', 'class' => array('links', 'clearfix', 'main-menu')))); ?>
        <?php print theme('links', array('links' => $secondary_menu, 'attributes' => array('id' => 'secondary', 'class' => array('links', 'clearfix', 'sub-menu')))); ?>
      </div>
    <?php endif; ?>

    <?php if ($page['sidebar_first']): ?>
      <div id="sidebar-first" class="column sidebar first">
        <div id="sidebar-first-inner" class="inner">
          <?php print render($page['sidebar_first']); ?>
        </div>
      </div>
    <?php endif; ?> <!-- /sidebar-first -->

    <?php if ($page['sidebar_second']): ?>
      <div id="sidebar-second" class="column sidebar second">
        <div id="sidebar-second-inner" class="inner">
          <?php print render($page['sidebar_second']); ?>
        </div>
      </div>
    <?php endif; ?> <!-- /sidebar-second -->

  </div> <!-- /main -->

</div> <!-- /page -->

<!-- ______________________ FOOTER _______________________ -->

  <div id="footer-section">
  <hr class="footer-bar" />
	    <div class="fmc-verson-time">
	      <div style="float: left" class="fmc-version-footer">
					<?php
					$vers = mercury_utilities_get_fmc_version_string();
					$id = mercury_utilities_get_fmc_asup_uuid();
					print "$vers@$id";
					?>
				</div>
				<div class="clientTime" style="float: right">							
          <?php
          // Get the copyright statement
          $copyright = mercury_utilities_get_fmc_copyright_string();
          print '<a href="/copyright">' . $copyright . '</a> ';
          if (!empty($user->uid)) {
            print ' ' . date('m/d/Y H:i') .
            ' <a href="/config/fmc/user/' .  $user->uid . '" title="Click to change timezone.">' . date('T') . '</a>';
          }
          ?>
				</div>
			</div>      
    </div> <!-- /footer -->
    
  

