#!/bin/bash

PATH=/sbin:/bin:/usr/bin:/usr/sbin

if [ $1"." = "." ] ; then
   echo "Error: Invalid update operation"
   exit 1
fi

if [ "$1" = "windows" ] ; then
   update_windows="1"
fi
if [ "$1" = "esx" ] ; then
   update_esx="1"
fi

# Check CDROM device exists
if [ ! -b /dev/cdrom ] ; then
    echo "Error: No cdrom device found"
    exit 1
fi

#/bin/mkdir -p /opt/flashaccel/agent/iso
#/bin/mount -t iso9660 /dev/cdrom /opt/flashaccel/agent/iso > /dev/null 2> /dev/null
/bin/umount /cdrom
/bin/mount /cdrom > /dev/null 2> /dev/null
if [ $? -ne 0 ] ; then
    echo "Error: Cannot mount cdrom device"
    exit 1
fi

# Compare the contents of the /op/flashaccel/agent
if [ $update_esx"x" = "1x" ] ; then
    if [ ! -f /cdrom/*.zip ] ; then
	echo "Error: No Flash Accel host agent bundle found"
	/bin/umount /cdrom
	exit 1
    fi
    iso_zip_cksum=`/usr/bin/sha1sum /cdrom/*.zip | cut -d' ' -f 1`
    fmc_zip_cksum=`/usr/bin/sha1sum /opt/flashaccel/agent/esx/*.zip | cut -d' ' -f 1`
    if [ "$iso_zip_cksum" = "$fmc_zip_cksum" ] ; then
	echo "Error: No new Flash Accel host agent found"
	/bin/umount /cdrom
	exit 1
    fi

    # Backup the current package contents and then update
    /bin/mkdir -p /opt/flashaccel/agent/backup/esx
    /bin/cp -f /opt/flashaccel/agent/esx/*.zip /opt/flashaccel/agent/backup/esx
    /bin/rm -f /opt/flashaccel/agent/esx/*.zip
    /bin/cp -f /cdrom/*.zip /opt/flashaccel/agent/esx
    /bin/ls /opt/flashaccel/agent/esx
fi

if [ $update_windows"x" = "1x" ] ; then
    if [ ! -f /cdrom/*.msi ] ; then
        echo "Error: No Flash Accel VM agent package found"
	/bin/umount /cdrom
        exit 1
    fi
    iso_msi_cksum=`/usr/bin/sha1sum /cdrom/*.msi | cut -d' ' -f 1`
    fmc_msi_cksum=`/usr/bin/sha1sum /opt/flashaccel/agent/windows/*.msi | cut -d' ' -f 1`
    if [ "$iso_msi_cksum" = "$fmc_msi_cksum" ] ; then
        echo "Error: No new Flash Accel VM agent found"
	/bin/umount /cdrom
        exit 1
    fi

    # Backup the current package contents and then update
    /bin/mkdir -p /opt/flashaccel/agent/backup/windows
    /bin/cp -f /opt/flashaccel/agent/windows/*.msi /opt/flashaccel/agent/backup/windows
    /bin/rm -f /opt/flashaccel/agent/windows/*.msi
    /bin/cp -f /cdrom/*.msi /opt/flashaccel/agent/windows
    /bin/ls /opt/flashaccel/agent/windows
fi

# unmount cdrom
/bin/umount /cdrom

